/* Layout.c generated by valac 0.56.14, the Vala compiler
 * generated from Layout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
#define NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BOUNDS, NodeBounds))
#define NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_BOUNDS, NodeBoundsClass))
#define IS_NODE_BOUNDS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BOUNDS))
#define IS_NODE_BOUNDS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_BOUNDS))
#define NODE_BOUNDS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_BOUNDS, NodeBoundsClass))

typedef struct _NodeBounds NodeBounds;
typedef struct _NodeBoundsClass NodeBoundsClass;
enum  {
	LAYOUT_0_PROPERTY,
	LAYOUT_NAME_PROPERTY,
	LAYOUT_ICON_PROPERTY,
	LAYOUT_BALANCEABLE_PROPERTY,
	LAYOUT_NUM_PROPERTIES
};
static GParamSpec* layout_properties[LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block23Data Block23Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _node_bounds_unref0(var) ((var == NULL) ? NULL : (var = (node_bounds_unref (var), NULL)))

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	NodeBounds* (*bbox) (Layout* self, Node* parent, gint side_mask);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* p, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutPrivate {
	gchar* _name;
	gchar* _icon;
	gboolean _balanceable;
};

struct _Block23Data {
	int _ref_count_;
	Layout* self;
	Node* parent;
};

static gint Layout_private_offset;
static gpointer layout_parent_class = NULL;

VALA_EXTERN GType layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN gpointer node_bounds_ref (gpointer instance);
VALA_EXTERN void node_bounds_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_bounds (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_node_bounds (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_node_bounds (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_node_bounds (const GValue* value);
VALA_EXTERN GType node_bounds_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeBounds, node_bounds_unref)
VALA_EXTERN NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
VALA_EXTERN void layout_initialize (Layout* self,
                        Node* parent);
VALA_EXTERN NodeBounds* layout_bbox (Layout* self,
                         Node* parent,
                         gint side_mask);
VALA_EXTERN void layout_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount);
VALA_EXTERN void layout_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* p,
                             gdouble amount,
                             const gchar* msg);
VALA_EXTERN void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
VALA_EXTERN NodeSide layout_get_side (Layout* self,
                          Node* n);
VALA_EXTERN void layout_set_side (Layout* self,
                      Node* current);
VALA_EXTERN void layout_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh);
VALA_EXTERN void layout_handle_update_by_fold (Layout* self,
                                   Node* n);
VALA_EXTERN gdouble layout_get_insert_adjust (Layout* self,
                                  Node* child);
VALA_EXTERN void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
VALA_EXTERN void layout_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size);
VALA_EXTERN void layout_position_root (Layout* self,
                           Node* last,
                           Node* n);
VALA_EXTERN Layout* layout_new (void);
VALA_EXTERN Layout* layout_construct (GType object_type);
static NodeSide layout_real_side_mapping (Layout* self,
                                   NodeSide side);
static void layout_real_initialize (Layout* self,
                             Node* parent);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
VALA_EXTERN GArray* node_children (Node* self);
VALA_EXTERN NodeSide node_get_side (Node* self);
VALA_EXTERN void node_set_side (Node* self,
                    NodeSide value);
static void __lambda38_ (Layout* self,
                  Node* item);
VALA_EXTERN void node_detach (Node* self,
                  NodeSide side);
static void ___lambda38__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda89_ (Block23Data* _data23_,
                  Node* item);
VALA_EXTERN void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void ___lambda89__gfunc (gconstpointer data,
                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static NodeBounds* layout_real_bbox (Layout* self,
                              Node* parent,
                              gint side_mask);
VALA_EXTERN void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN DrawArea* node_get_da (Node* self);
VALA_EXTERN NodeBounds* node_bounds_new_with_bounds (DrawArea* da,
                                         gdouble x,
                                         gdouble y,
                                         gdouble w,
                                         gdouble h);
VALA_EXTERN NodeBounds* node_bounds_construct_with_bounds (GType object_type,
                                               DrawArea* da,
                                               gdouble x,
                                               gdouble y,
                                               gdouble w,
                                               gdouble h);
VALA_EXTERN gdouble node_bounds_get_x (NodeBounds* self);
VALA_EXTERN gdouble node_bounds_get_width (NodeBounds* self);
VALA_EXTERN gdouble node_bounds_get_y (NodeBounds* self);
VALA_EXTERN gdouble node_bounds_get_height (NodeBounds* self);
VALA_EXTERN gboolean node_get_folded (Node* self);
VALA_EXTERN NodeBounds* node_get_tree_bbox (Node* self);
VALA_EXTERN void node_bounds_set_x (NodeBounds* self,
                        gdouble value);
VALA_EXTERN void node_bounds_set_y (NodeBounds* self,
                        gdouble value);
VALA_EXTERN void node_bounds_set_width (NodeBounds* self,
                            gdouble value);
VALA_EXTERN void node_bounds_set_height (NodeBounds* self,
                             gdouble value);
VALA_EXTERN void layout_update_tree_size (Layout* self,
                              Node* n);
VALA_EXTERN void node_set_tree_bbox (Node* self,
                         NodeBounds* value);
VALA_EXTERN gint node_side_horizontal (void);
VALA_EXTERN void node_set_tree_size (Node* self,
                         gdouble value);
VALA_EXTERN gdouble layout_get_adjust (Layout* self,
                           Node* parent);
VALA_EXTERN gdouble node_get_tree_size (Node* self);
static void layout_real_adjust_tree (Layout* self,
                              Node* parent,
                              gint child_index,
                              gint side_mask,
                              gdouble amount);
VALA_EXTERN gdouble node_get_posy (Node* self);
VALA_EXTERN void node_set_posy (Node* self,
                    gdouble value);
VALA_EXTERN gdouble node_get_posx (Node* self);
VALA_EXTERN void node_set_posx (Node* self,
                    gdouble value);
static void layout_real_adjust_tree_all (Layout* self,
                                  Node* n,
                                  NodeBounds* p,
                                  gdouble amount,
                                  const gchar* msg);
VALA_EXTERN Node* node_get_parent (Node* self);
VALA_EXTERN gint node_index (Node* self);
VALA_EXTERN GArray* draw_area_get_nodes (DrawArea* self);
VALA_EXTERN NodeBounds* node_bounds_new_copy (NodeBounds* nb);
VALA_EXTERN NodeBounds* node_bounds_construct_copy (GType object_type,
                                        NodeBounds* nb);
VALA_EXTERN void node_bounds_copy_from (NodeBounds* self,
                            NodeBounds* nb);
VALA_EXTERN void draw_area_handle_tree_overlap (DrawArea* self,
                                    NodeBounds* prev);
static void layout_real_propagate_side (Layout* self,
                                 Node* parent,
                                 NodeSide side);
VALA_EXTERN gpointer style_ref (gpointer instance);
VALA_EXTERN void style_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_style (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_style (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_style (const GValue* value);
VALA_EXTERN GType style_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
VALA_EXTERN Style* node_get_style (Node* self);
VALA_EXTERN gint* style_get_branch_margin (Style* self);
static gint* _int_dup (gint* self);
static NodeSide layout_real_get_side (Layout* self,
                               Node* n);
VALA_EXTERN Node* node_get_root (Node* self);
static void layout_real_set_side (Layout* self,
                           Node* current);
VALA_EXTERN gboolean node_is_root (Node* self);
VALA_EXTERN void layout_apply_margin (Layout* self,
                          Node* n);
VALA_EXTERN gdouble node_task_width (Node* self);
static void layout_real_handle_update_by_edit (Layout* self,
                                        Node* n,
                                        gdouble diffw,
                                        gdouble diffh);
VALA_EXTERN void node_adjust_posy_only (Node* self,
                            gdouble value);
VALA_EXTERN void node_adjust_posx_only (Node* self,
                            gdouble value);
static void layout_real_handle_update_by_fold (Layout* self,
                                        Node* n);
static gdouble layout_real_get_insert_adjust (Layout* self,
                                       Node* child);
static void layout_real_handle_update_by_insert (Layout* self,
                                          Node* parent,
                                          Node* child,
                                          gint pos);
VALA_EXTERN gint node_side_count (Node* self,
                      NodeSide side);
static void layout_real_handle_update_by_delete (Layout* self,
                                          Node* parent,
                                          gint index,
                                          NodeSide side,
                                          gdouble size);
static void layout_real_position_root (Layout* self,
                                Node* last,
                                Node* n);
VALA_EXTERN const gchar* layout_get_name (Layout* self);
VALA_EXTERN void layout_set_name (Layout* self,
                      const gchar* value);
VALA_EXTERN const gchar* layout_get_icon (Layout* self);
VALA_EXTERN void layout_set_icon (Layout* self,
                      const gchar* value);
VALA_EXTERN gboolean layout_get_balanceable (Layout* self);
VALA_EXTERN void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_finalize (GObject * obj);
static GType layout_get_type_once (void);
static void _vala_layout_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_layout_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
layout_get_instance_private (Layout* self)
{
	return G_STRUCT_MEMBER_P (self, Layout_private_offset);
}

Layout*
layout_construct (GType object_type)
{
	Layout * self = NULL;
#line 31 "../src/Layout.vala"
	self = (Layout*) g_object_new (object_type, NULL);
#line 31 "../src/Layout.vala"
	return self;
#line 408 "Layout.c"
}

Layout*
layout_new (void)
{
#line 31 "../src/Layout.vala"
	return layout_construct (TYPE_LAYOUT);
#line 416 "Layout.c"
}

static NodeSide
layout_real_side_mapping (Layout* self,
                          NodeSide side)
{
	NodeSide result;
#line 38 "../src/Layout.vala"
	switch (side) {
#line 38 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 428 "Layout.c"
		{
#line 39 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 39 "../src/Layout.vala"
			return result;
#line 434 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 438 "Layout.c"
		{
#line 40 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 40 "../src/Layout.vala"
			return result;
#line 444 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 448 "Layout.c"
		{
#line 41 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 41 "../src/Layout.vala"
			return result;
#line 454 "Layout.c"
		}
#line 38 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 458 "Layout.c"
		{
#line 42 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 42 "../src/Layout.vala"
			return result;
#line 464 "Layout.c"
		}
		default:
#line 38 "../src/Layout.vala"
		break;
#line 469 "Layout.c"
	}
#line 44 "../src/Layout.vala"
	result = NODE_SIDE_RIGHT;
#line 44 "../src/Layout.vala"
	return result;
#line 475 "Layout.c"
}

NodeSide
layout_side_mapping (Layout* self,
                     NodeSide side)
{
	LayoutClass* _klass_;
#line 37 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 37 "../src/Layout.vala"
	if (_klass_->side_mapping) {
#line 37 "../src/Layout.vala"
		return _klass_->side_mapping (self, side);
#line 491 "Layout.c"
	}
#line 37 "../src/Layout.vala"
	return 0;
#line 495 "Layout.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/Layout.vala"
	return self ? g_object_ref (self) : NULL;
#line 503 "Layout.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 48 "../src/Layout.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 48 "../src/Layout.vala"
	return _data23_;
#line 513 "Layout.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 48 "../src/Layout.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 523 "Layout.c"
		Layout* self;
#line 48 "../src/Layout.vala"
		self = _data23_->self;
#line 48 "../src/Layout.vala"
		_g_object_unref0 (_data23_->parent);
#line 48 "../src/Layout.vala"
		_g_object_unref0 (self);
#line 48 "../src/Layout.vala"
		g_slice_free (Block23Data, _data23_);
#line 533 "Layout.c"
	}
}

static void
__lambda38_ (Layout* self,
             Node* item)
{
	NodeSide _tmp0_;
	NodeSide _tmp1_;
#line 56 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 57 "../src/Layout.vala"
	_tmp0_ = node_get_side (item);
#line 57 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/Layout.vala"
	node_detach (item, _tmp1_);
#line 551 "Layout.c"
}

static void
___lambda38__gfunc (gconstpointer data,
                    gpointer self)
{
#line 56 "../src/Layout.vala"
	__lambda38_ ((Layout*) self, (Node*) data);
#line 560 "Layout.c"
}

static void
__lambda89_ (Block23Data* _data23_,
             Node* item)
{
	Layout* self;
#line 59 "../src/Layout.vala"
	self = _data23_->self;
#line 59 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 60 "../src/Layout.vala"
	node_attach_init (item, _data23_->parent, -1);
#line 574 "Layout.c"
}

static void
___lambda89__gfunc (gconstpointer data,
                    gpointer self)
{
#line 59 "../src/Layout.vala"
	__lambda89_ (self, (Node*) data);
#line 583 "Layout.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 48 "../src/Layout.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 591 "Layout.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 48 "../src/Layout.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 599 "Layout.c"
}

static void
layout_real_initialize (Layout* self,
                        Node* parent)
{
	Block23Data* _data23_;
	Node* _tmp0_;
	GSList* list = NULL;
	GSList* _tmp18_;
	GSList* _tmp19_;
#line 48 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 48 "../src/Layout.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 48 "../src/Layout.vala"
	_data23_->_ref_count_ = 1;
#line 48 "../src/Layout.vala"
	_data23_->self = g_object_ref (self);
#line 48 "../src/Layout.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 48 "../src/Layout.vala"
	_g_object_unref0 (_data23_->parent);
#line 48 "../src/Layout.vala"
	_data23_->parent = _tmp0_;
#line 49 "../src/Layout.vala"
	list = NULL;
#line 627 "Layout.c"
	{
		gint i = 0;
#line 50 "../src/Layout.vala"
		i = 0;
#line 632 "Layout.c"
		{
			gboolean _tmp1_ = FALSE;
#line 50 "../src/Layout.vala"
			_tmp1_ = TRUE;
#line 50 "../src/Layout.vala"
			while (TRUE) {
#line 639 "Layout.c"
				GArray* _tmp3_;
				GArray* _tmp4_;
				gboolean _tmp5_;
				Node* n = NULL;
				GArray* _tmp6_;
				GArray* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				NodeSide _tmp14_;
				NodeSide _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
#line 50 "../src/Layout.vala"
				if (!_tmp1_) {
#line 658 "Layout.c"
					gint _tmp2_;
#line 50 "../src/Layout.vala"
					_tmp2_ = i;
#line 50 "../src/Layout.vala"
					i = _tmp2_ + 1;
#line 664 "Layout.c"
				}
#line 50 "../src/Layout.vala"
				_tmp1_ = FALSE;
#line 50 "../src/Layout.vala"
				_tmp3_ = node_children (_data23_->parent);
#line 50 "../src/Layout.vala"
				_tmp4_ = _tmp3_;
#line 50 "../src/Layout.vala"
				_tmp5_ = !(((guint) i) < _tmp4_->len);
#line 50 "../src/Layout.vala"
				_g_array_unref0 (_tmp4_);
#line 50 "../src/Layout.vala"
				if (_tmp5_) {
#line 50 "../src/Layout.vala"
					break;
#line 680 "Layout.c"
				}
#line 51 "../src/Layout.vala"
				_tmp6_ = node_children (_data23_->parent);
#line 51 "../src/Layout.vala"
				_tmp7_ = _tmp6_;
#line 51 "../src/Layout.vala"
				_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
#line 51 "../src/Layout.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 51 "../src/Layout.vala"
				_tmp10_ = _tmp9_;
#line 51 "../src/Layout.vala"
				_g_array_unref0 (_tmp7_);
#line 51 "../src/Layout.vala"
				n = _tmp10_;
#line 52 "../src/Layout.vala"
				_tmp11_ = n;
#line 52 "../src/Layout.vala"
				layout_initialize (self, _tmp11_);
#line 53 "../src/Layout.vala"
				_tmp12_ = n;
#line 53 "../src/Layout.vala"
				_tmp13_ = n;
#line 53 "../src/Layout.vala"
				_tmp14_ = node_get_side (_tmp13_);
#line 53 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 53 "../src/Layout.vala"
				node_set_side (_tmp12_, layout_side_mapping (self, _tmp15_));
#line 54 "../src/Layout.vala"
				_tmp16_ = n;
#line 54 "../src/Layout.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 54 "../src/Layout.vala"
				list = g_slist_append (list, _tmp17_);
#line 50 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 718 "Layout.c"
			}
		}
	}
#line 56 "../src/Layout.vala"
	_tmp18_ = list;
#line 56 "../src/Layout.vala"
	g_slist_foreach (_tmp18_, ___lambda38__gfunc, self);
#line 59 "../src/Layout.vala"
	_tmp19_ = list;
#line 59 "../src/Layout.vala"
	g_slist_foreach (_tmp19_, ___lambda89__gfunc, _data23_);
#line 48 "../src/Layout.vala"
	(list == NULL) ? NULL : (list = (_g_slist_free__g_object_unref0_ (list), NULL));
#line 48 "../src/Layout.vala"
	block23_data_unref (_data23_);
#line 48 "../src/Layout.vala"
	_data23_ = NULL;
#line 736 "Layout.c"
}

void
layout_initialize (Layout* self,
                   Node* parent)
{
	LayoutClass* _klass_;
#line 48 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 48 "../src/Layout.vala"
	if (_klass_->initialize) {
#line 48 "../src/Layout.vala"
		_klass_->initialize (self, parent);
#line 752 "Layout.c"
	}
}

static gpointer
_node_bounds_ref0 (gpointer self)
{
#line 80 "../src/Layout.vala"
	return self ? node_bounds_ref (self) : NULL;
#line 761 "Layout.c"
}

static NodeBounds*
layout_real_bbox (Layout* self,
                  Node* parent,
                  gint side_mask)
{
	guint num_children = 0U;
	GArray* _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	NodeBounds* nb = NULL;
	DrawArea* _tmp7_;
	DrawArea* _tmp8_;
	NodeBounds* _tmp9_;
	gdouble x2 = 0.0;
	NodeBounds* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	NodeBounds* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble y2 = 0.0;
	NodeBounds* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	NodeBounds* _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gboolean _tmp22_ = FALSE;
	NodeBounds* _tmp97_;
	NodeBounds* _tmp98_;
	gdouble _tmp99_;
	gdouble _tmp100_;
	NodeBounds* _tmp101_;
	NodeBounds* _tmp102_;
	gdouble _tmp103_;
	gdouble _tmp104_;
	NodeBounds* result;
#line 65 "../src/Layout.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 67 "../src/Layout.vala"
	_tmp0_ = node_children (parent);
#line 67 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/Layout.vala"
	_tmp2_ = _tmp1_->len;
#line 67 "../src/Layout.vala"
	_g_array_unref0 (_tmp1_);
#line 67 "../src/Layout.vala"
	num_children = _tmp2_;
#line 70 "../src/Layout.vala"
	node_bbox (parent, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 70 "../src/Layout.vala"
	px = _tmp3_;
#line 70 "../src/Layout.vala"
	py = _tmp4_;
#line 70 "../src/Layout.vala"
	pw = _tmp5_;
#line 70 "../src/Layout.vala"
	ph = _tmp6_;
#line 72 "../src/Layout.vala"
	_tmp7_ = node_get_da (parent);
#line 72 "../src/Layout.vala"
	_tmp8_ = _tmp7_;
#line 72 "../src/Layout.vala"
	_tmp9_ = node_bounds_new_with_bounds (_tmp8_, px, py, pw, ph);
#line 72 "../src/Layout.vala"
	nb = _tmp9_;
#line 74 "../src/Layout.vala"
	_tmp10_ = nb;
#line 74 "../src/Layout.vala"
	_tmp11_ = node_bounds_get_x (_tmp10_);
#line 74 "../src/Layout.vala"
	_tmp12_ = _tmp11_;
#line 74 "../src/Layout.vala"
	_tmp13_ = nb;
#line 74 "../src/Layout.vala"
	_tmp14_ = node_bounds_get_width (_tmp13_);
#line 74 "../src/Layout.vala"
	_tmp15_ = _tmp14_;
#line 74 "../src/Layout.vala"
	x2 = _tmp12_ + _tmp15_;
#line 75 "../src/Layout.vala"
	_tmp16_ = nb;
#line 75 "../src/Layout.vala"
	_tmp17_ = node_bounds_get_y (_tmp16_);
#line 75 "../src/Layout.vala"
	_tmp18_ = _tmp17_;
#line 75 "../src/Layout.vala"
	_tmp19_ = nb;
#line 75 "../src/Layout.vala"
	_tmp20_ = node_bounds_get_height (_tmp19_);
#line 75 "../src/Layout.vala"
	_tmp21_ = _tmp20_;
#line 75 "../src/Layout.vala"
	y2 = _tmp18_ + _tmp21_;
#line 77 "../src/Layout.vala"
	if (num_children != ((guint) 0)) {
#line 869 "Layout.c"
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 77 "../src/Layout.vala"
		_tmp23_ = node_get_folded (parent);
#line 77 "../src/Layout.vala"
		_tmp24_ = _tmp23_;
#line 77 "../src/Layout.vala"
		_tmp22_ = !_tmp24_;
#line 878 "Layout.c"
	} else {
#line 77 "../src/Layout.vala"
		_tmp22_ = FALSE;
#line 882 "Layout.c"
	}
#line 77 "../src/Layout.vala"
	if (_tmp22_) {
#line 886 "Layout.c"
		{
			gint i = 0;
#line 78 "../src/Layout.vala"
			i = 0;
#line 891 "Layout.c"
			{
				gboolean _tmp25_ = FALSE;
#line 78 "../src/Layout.vala"
				_tmp25_ = TRUE;
#line 78 "../src/Layout.vala"
				while (TRUE) {
#line 898 "Layout.c"
					GArray* _tmp27_;
					GArray* _tmp28_;
					gboolean _tmp29_;
					GArray* _tmp30_;
					GArray* _tmp31_;
					Node* _tmp32_;
					NodeSide _tmp33_;
					NodeSide _tmp34_;
					gboolean _tmp35_;
#line 78 "../src/Layout.vala"
					if (!_tmp25_) {
#line 910 "Layout.c"
						gint _tmp26_;
#line 78 "../src/Layout.vala"
						_tmp26_ = i;
#line 78 "../src/Layout.vala"
						i = _tmp26_ + 1;
#line 916 "Layout.c"
					}
#line 78 "../src/Layout.vala"
					_tmp25_ = FALSE;
#line 78 "../src/Layout.vala"
					_tmp27_ = node_children (parent);
#line 78 "../src/Layout.vala"
					_tmp28_ = _tmp27_;
#line 78 "../src/Layout.vala"
					_tmp29_ = !(((guint) i) < _tmp28_->len);
#line 78 "../src/Layout.vala"
					_g_array_unref0 (_tmp28_);
#line 78 "../src/Layout.vala"
					if (_tmp29_) {
#line 78 "../src/Layout.vala"
						break;
#line 932 "Layout.c"
					}
#line 79 "../src/Layout.vala"
					_tmp30_ = node_children (parent);
#line 79 "../src/Layout.vala"
					_tmp31_ = _tmp30_;
#line 79 "../src/Layout.vala"
					_tmp32_ = g_array_index (_tmp31_, Node*, (guint) i);
#line 79 "../src/Layout.vala"
					_tmp33_ = node_get_side (_tmp32_);
#line 79 "../src/Layout.vala"
					_tmp34_ = _tmp33_;
#line 79 "../src/Layout.vala"
					_tmp35_ = (_tmp34_ & side_mask) != 0;
#line 79 "../src/Layout.vala"
					_g_array_unref0 (_tmp31_);
#line 79 "../src/Layout.vala"
					if (_tmp35_) {
#line 950 "Layout.c"
						NodeBounds* cb = NULL;
						GArray* _tmp36_;
						GArray* _tmp37_;
						Node* _tmp38_;
						NodeBounds* _tmp39_;
						NodeBounds* _tmp40_;
						NodeBounds* _tmp41_;
						NodeBounds* _tmp42_;
						gdouble _tmp43_ = 0.0;
						NodeBounds* _tmp44_;
						gdouble _tmp45_;
						gdouble _tmp46_;
						NodeBounds* _tmp47_;
						gdouble _tmp48_;
						gdouble _tmp49_;
						NodeBounds* _tmp56_;
						gdouble _tmp57_ = 0.0;
						NodeBounds* _tmp58_;
						gdouble _tmp59_;
						gdouble _tmp60_;
						NodeBounds* _tmp61_;
						gdouble _tmp62_;
						gdouble _tmp63_;
						NodeBounds* _tmp70_;
						gdouble _tmp71_ = 0.0;
						NodeBounds* _tmp72_;
						gdouble _tmp73_;
						gdouble _tmp74_;
						NodeBounds* _tmp75_;
						gdouble _tmp76_;
						gdouble _tmp77_;
						gdouble _tmp84_ = 0.0;
						NodeBounds* _tmp85_;
						gdouble _tmp86_;
						gdouble _tmp87_;
						NodeBounds* _tmp88_;
						gdouble _tmp89_;
						gdouble _tmp90_;
#line 80 "../src/Layout.vala"
						_tmp36_ = node_children (parent);
#line 80 "../src/Layout.vala"
						_tmp37_ = _tmp36_;
#line 80 "../src/Layout.vala"
						_tmp38_ = g_array_index (_tmp37_, Node*, (guint) i);
#line 80 "../src/Layout.vala"
						_tmp39_ = node_get_tree_bbox (_tmp38_);
#line 80 "../src/Layout.vala"
						_tmp40_ = _tmp39_;
#line 80 "../src/Layout.vala"
						_tmp41_ = _node_bounds_ref0 (_tmp40_);
#line 80 "../src/Layout.vala"
						_tmp42_ = _tmp41_;
#line 80 "../src/Layout.vala"
						_g_array_unref0 (_tmp37_);
#line 80 "../src/Layout.vala"
						cb = _tmp42_;
#line 81 "../src/Layout.vala"
						_tmp44_ = nb;
#line 81 "../src/Layout.vala"
						_tmp45_ = node_bounds_get_x (_tmp44_);
#line 81 "../src/Layout.vala"
						_tmp46_ = _tmp45_;
#line 81 "../src/Layout.vala"
						_tmp47_ = cb;
#line 81 "../src/Layout.vala"
						_tmp48_ = node_bounds_get_x (_tmp47_);
#line 81 "../src/Layout.vala"
						_tmp49_ = _tmp48_;
#line 81 "../src/Layout.vala"
						if (_tmp46_ < _tmp49_) {
#line 1021 "Layout.c"
							NodeBounds* _tmp50_;
							gdouble _tmp51_;
							gdouble _tmp52_;
#line 81 "../src/Layout.vala"
							_tmp50_ = nb;
#line 81 "../src/Layout.vala"
							_tmp51_ = node_bounds_get_x (_tmp50_);
#line 81 "../src/Layout.vala"
							_tmp52_ = _tmp51_;
#line 81 "../src/Layout.vala"
							_tmp43_ = _tmp52_;
#line 1033 "Layout.c"
						} else {
							NodeBounds* _tmp53_;
							gdouble _tmp54_;
							gdouble _tmp55_;
#line 81 "../src/Layout.vala"
							_tmp53_ = cb;
#line 81 "../src/Layout.vala"
							_tmp54_ = node_bounds_get_x (_tmp53_);
#line 81 "../src/Layout.vala"
							_tmp55_ = _tmp54_;
#line 81 "../src/Layout.vala"
							_tmp43_ = _tmp55_;
#line 1046 "Layout.c"
						}
#line 81 "../src/Layout.vala"
						_tmp56_ = nb;
#line 81 "../src/Layout.vala"
						node_bounds_set_x (_tmp56_, _tmp43_);
#line 82 "../src/Layout.vala"
						_tmp58_ = nb;
#line 82 "../src/Layout.vala"
						_tmp59_ = node_bounds_get_y (_tmp58_);
#line 82 "../src/Layout.vala"
						_tmp60_ = _tmp59_;
#line 82 "../src/Layout.vala"
						_tmp61_ = cb;
#line 82 "../src/Layout.vala"
						_tmp62_ = node_bounds_get_y (_tmp61_);
#line 82 "../src/Layout.vala"
						_tmp63_ = _tmp62_;
#line 82 "../src/Layout.vala"
						if (_tmp60_ < _tmp63_) {
#line 1066 "Layout.c"
							NodeBounds* _tmp64_;
							gdouble _tmp65_;
							gdouble _tmp66_;
#line 82 "../src/Layout.vala"
							_tmp64_ = nb;
#line 82 "../src/Layout.vala"
							_tmp65_ = node_bounds_get_y (_tmp64_);
#line 82 "../src/Layout.vala"
							_tmp66_ = _tmp65_;
#line 82 "../src/Layout.vala"
							_tmp57_ = _tmp66_;
#line 1078 "Layout.c"
						} else {
							NodeBounds* _tmp67_;
							gdouble _tmp68_;
							gdouble _tmp69_;
#line 82 "../src/Layout.vala"
							_tmp67_ = cb;
#line 82 "../src/Layout.vala"
							_tmp68_ = node_bounds_get_y (_tmp67_);
#line 82 "../src/Layout.vala"
							_tmp69_ = _tmp68_;
#line 82 "../src/Layout.vala"
							_tmp57_ = _tmp69_;
#line 1091 "Layout.c"
						}
#line 82 "../src/Layout.vala"
						_tmp70_ = nb;
#line 82 "../src/Layout.vala"
						node_bounds_set_y (_tmp70_, _tmp57_);
#line 83 "../src/Layout.vala"
						_tmp72_ = cb;
#line 83 "../src/Layout.vala"
						_tmp73_ = node_bounds_get_x (_tmp72_);
#line 83 "../src/Layout.vala"
						_tmp74_ = _tmp73_;
#line 83 "../src/Layout.vala"
						_tmp75_ = cb;
#line 83 "../src/Layout.vala"
						_tmp76_ = node_bounds_get_width (_tmp75_);
#line 83 "../src/Layout.vala"
						_tmp77_ = _tmp76_;
#line 83 "../src/Layout.vala"
						if (x2 < (_tmp74_ + _tmp77_)) {
#line 1111 "Layout.c"
							NodeBounds* _tmp78_;
							gdouble _tmp79_;
							gdouble _tmp80_;
							NodeBounds* _tmp81_;
							gdouble _tmp82_;
							gdouble _tmp83_;
#line 83 "../src/Layout.vala"
							_tmp78_ = cb;
#line 83 "../src/Layout.vala"
							_tmp79_ = node_bounds_get_x (_tmp78_);
#line 83 "../src/Layout.vala"
							_tmp80_ = _tmp79_;
#line 83 "../src/Layout.vala"
							_tmp81_ = cb;
#line 83 "../src/Layout.vala"
							_tmp82_ = node_bounds_get_width (_tmp81_);
#line 83 "../src/Layout.vala"
							_tmp83_ = _tmp82_;
#line 83 "../src/Layout.vala"
							_tmp71_ = _tmp80_ + _tmp83_;
#line 1132 "Layout.c"
						} else {
#line 83 "../src/Layout.vala"
							_tmp71_ = x2;
#line 1136 "Layout.c"
						}
#line 83 "../src/Layout.vala"
						x2 = _tmp71_;
#line 84 "../src/Layout.vala"
						_tmp85_ = cb;
#line 84 "../src/Layout.vala"
						_tmp86_ = node_bounds_get_y (_tmp85_);
#line 84 "../src/Layout.vala"
						_tmp87_ = _tmp86_;
#line 84 "../src/Layout.vala"
						_tmp88_ = cb;
#line 84 "../src/Layout.vala"
						_tmp89_ = node_bounds_get_height (_tmp88_);
#line 84 "../src/Layout.vala"
						_tmp90_ = _tmp89_;
#line 84 "../src/Layout.vala"
						if (y2 < (_tmp87_ + _tmp90_)) {
#line 1154 "Layout.c"
							NodeBounds* _tmp91_;
							gdouble _tmp92_;
							gdouble _tmp93_;
							NodeBounds* _tmp94_;
							gdouble _tmp95_;
							gdouble _tmp96_;
#line 84 "../src/Layout.vala"
							_tmp91_ = cb;
#line 84 "../src/Layout.vala"
							_tmp92_ = node_bounds_get_y (_tmp91_);
#line 84 "../src/Layout.vala"
							_tmp93_ = _tmp92_;
#line 84 "../src/Layout.vala"
							_tmp94_ = cb;
#line 84 "../src/Layout.vala"
							_tmp95_ = node_bounds_get_height (_tmp94_);
#line 84 "../src/Layout.vala"
							_tmp96_ = _tmp95_;
#line 84 "../src/Layout.vala"
							_tmp84_ = _tmp93_ + _tmp96_;
#line 1175 "Layout.c"
						} else {
#line 84 "../src/Layout.vala"
							_tmp84_ = y2;
#line 1179 "Layout.c"
						}
#line 84 "../src/Layout.vala"
						y2 = _tmp84_;
#line 79 "../src/Layout.vala"
						_node_bounds_unref0 (cb);
#line 1185 "Layout.c"
					}
				}
			}
		}
	}
#line 89 "../src/Layout.vala"
	_tmp97_ = nb;
#line 89 "../src/Layout.vala"
	_tmp98_ = nb;
#line 89 "../src/Layout.vala"
	_tmp99_ = node_bounds_get_x (_tmp98_);
#line 89 "../src/Layout.vala"
	_tmp100_ = _tmp99_;
#line 89 "../src/Layout.vala"
	node_bounds_set_width (_tmp97_, x2 - _tmp100_);
#line 90 "../src/Layout.vala"
	_tmp101_ = nb;
#line 90 "../src/Layout.vala"
	_tmp102_ = nb;
#line 90 "../src/Layout.vala"
	_tmp103_ = node_bounds_get_y (_tmp102_);
#line 90 "../src/Layout.vala"
	_tmp104_ = _tmp103_;
#line 90 "../src/Layout.vala"
	node_bounds_set_height (_tmp101_, y2 - _tmp104_);
#line 92 "../src/Layout.vala"
	result = nb;
#line 92 "../src/Layout.vala"
	return result;
#line 1215 "Layout.c"
}

NodeBounds*
layout_bbox (Layout* self,
             Node* parent,
             gint side_mask)
{
	LayoutClass* _klass_;
#line 65 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 65 "../src/Layout.vala"
	if (_klass_->bbox) {
#line 65 "../src/Layout.vala"
		return _klass_->bbox (self, parent, side_mask);
#line 1232 "Layout.c"
	}
#line 65 "../src/Layout.vala"
	return NULL;
#line 1236 "Layout.c"
}

void
layout_update_tree_size (Layout* self,
                         Node* n)
{
	NodeBounds* nb = NULL;
	NodeBounds* _tmp0_;
	NodeBounds* _tmp1_;
	gdouble _tmp2_ = 0.0;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
#line 97 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 100 "../src/Layout.vala"
	_tmp0_ = layout_bbox (self, n, -1);
#line 100 "../src/Layout.vala"
	nb = _tmp0_;
#line 103 "../src/Layout.vala"
	_tmp1_ = nb;
#line 103 "../src/Layout.vala"
	node_set_tree_bbox (n, _tmp1_);
#line 106 "../src/Layout.vala"
	_tmp3_ = node_get_side (n);
#line 106 "../src/Layout.vala"
	_tmp4_ = _tmp3_;
#line 106 "../src/Layout.vala"
	if ((_tmp4_ & node_side_horizontal ()) != 0) {
#line 1267 "Layout.c"
		NodeBounds* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 106 "../src/Layout.vala"
		_tmp5_ = nb;
#line 106 "../src/Layout.vala"
		_tmp6_ = node_bounds_get_height (_tmp5_);
#line 106 "../src/Layout.vala"
		_tmp7_ = _tmp6_;
#line 106 "../src/Layout.vala"
		_tmp2_ = _tmp7_;
#line 1279 "Layout.c"
	} else {
		NodeBounds* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
#line 106 "../src/Layout.vala"
		_tmp8_ = nb;
#line 106 "../src/Layout.vala"
		_tmp9_ = node_bounds_get_width (_tmp8_);
#line 106 "../src/Layout.vala"
		_tmp10_ = _tmp9_;
#line 106 "../src/Layout.vala"
		_tmp2_ = _tmp10_;
#line 1292 "Layout.c"
	}
#line 106 "../src/Layout.vala"
	node_set_tree_size (n, _tmp2_);
#line 97 "../src/Layout.vala"
	_node_bounds_unref0 (nb);
#line 1298 "Layout.c"
}

gdouble
layout_get_adjust (Layout* self,
                   Node* parent)
{
	gdouble orig_tree_size = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 114 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 114 "../src/Layout.vala"
	g_return_val_if_fail (parent != NULL, 0.0);
#line 116 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (parent);
#line 116 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/Layout.vala"
	orig_tree_size = _tmp1_;
#line 118 "../src/Layout.vala"
	layout_update_tree_size (self, parent);
#line 120 "../src/Layout.vala"
	if (orig_tree_size == ((gdouble) 0)) {
#line 120 "../src/Layout.vala"
		_tmp2_ = (gdouble) 0;
#line 1326 "Layout.c"
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 120 "../src/Layout.vala"
		_tmp3_ = node_get_tree_size (parent);
#line 120 "../src/Layout.vala"
		_tmp4_ = _tmp3_;
#line 120 "../src/Layout.vala"
		_tmp2_ = _tmp4_ - orig_tree_size;
#line 1336 "Layout.c"
	}
#line 120 "../src/Layout.vala"
	result = _tmp2_;
#line 120 "../src/Layout.vala"
	return result;
#line 1342 "Layout.c"
}

static void
layout_real_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount)
{
#line 125 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 1354 "Layout.c"
	{
		gint i = 0;
#line 127 "../src/Layout.vala"
		i = 0;
#line 1359 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 127 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 127 "../src/Layout.vala"
			while (TRUE) {
#line 1366 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
#line 127 "../src/Layout.vala"
				if (!_tmp0_) {
#line 1372 "Layout.c"
					gint _tmp1_;
#line 127 "../src/Layout.vala"
					_tmp1_ = i;
#line 127 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 1378 "Layout.c"
				}
#line 127 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 127 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 127 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 127 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 127 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 127 "../src/Layout.vala"
				if (_tmp4_) {
#line 127 "../src/Layout.vala"
					break;
#line 1394 "Layout.c"
				}
#line 128 "../src/Layout.vala"
				if (i != child_index) {
#line 1398 "Layout.c"
					Node* n = NULL;
					GArray* _tmp5_;
					GArray* _tmp6_;
					Node* _tmp7_;
					Node* _tmp8_;
					Node* _tmp9_;
					Node* _tmp10_;
					NodeSide _tmp11_;
					NodeSide _tmp12_;
#line 129 "../src/Layout.vala"
					_tmp5_ = node_children (parent);
#line 129 "../src/Layout.vala"
					_tmp6_ = _tmp5_;
#line 129 "../src/Layout.vala"
					_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 129 "../src/Layout.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 129 "../src/Layout.vala"
					_tmp9_ = _tmp8_;
#line 129 "../src/Layout.vala"
					_g_array_unref0 (_tmp6_);
#line 129 "../src/Layout.vala"
					n = _tmp9_;
#line 130 "../src/Layout.vala"
					_tmp10_ = n;
#line 130 "../src/Layout.vala"
					_tmp11_ = node_get_side (_tmp10_);
#line 130 "../src/Layout.vala"
					_tmp12_ = _tmp11_;
#line 130 "../src/Layout.vala"
					if ((_tmp12_ & side_mask) != 0) {
#line 1430 "Layout.c"
						Node* _tmp13_;
						NodeSide _tmp14_;
						NodeSide _tmp15_;
#line 131 "../src/Layout.vala"
						_tmp13_ = n;
#line 131 "../src/Layout.vala"
						_tmp14_ = node_get_side (_tmp13_);
#line 131 "../src/Layout.vala"
						_tmp15_ = _tmp14_;
#line 131 "../src/Layout.vala"
						if ((_tmp15_ & node_side_horizontal ()) != 0) {
#line 1442 "Layout.c"
							Node* _tmp16_;
							Node* _tmp17_;
							gdouble _tmp18_;
							gdouble _tmp19_;
#line 132 "../src/Layout.vala"
							_tmp16_ = n;
#line 132 "../src/Layout.vala"
							_tmp17_ = n;
#line 132 "../src/Layout.vala"
							_tmp18_ = node_get_posy (_tmp17_);
#line 132 "../src/Layout.vala"
							_tmp19_ = _tmp18_;
#line 132 "../src/Layout.vala"
							node_set_posy (_tmp17_, _tmp19_ + amount);
#line 1457 "Layout.c"
						} else {
							Node* _tmp20_;
							Node* _tmp21_;
							gdouble _tmp22_;
							gdouble _tmp23_;
#line 134 "../src/Layout.vala"
							_tmp20_ = n;
#line 134 "../src/Layout.vala"
							_tmp21_ = n;
#line 134 "../src/Layout.vala"
							_tmp22_ = node_get_posx (_tmp21_);
#line 134 "../src/Layout.vala"
							_tmp23_ = _tmp22_;
#line 134 "../src/Layout.vala"
							node_set_posx (_tmp21_, _tmp23_ + amount);
#line 1473 "Layout.c"
						}
					}
#line 128 "../src/Layout.vala"
					_g_object_unref0 (n);
#line 1478 "Layout.c"
				} else {
#line 138 "../src/Layout.vala"
					amount = 0 - amount;
#line 1482 "Layout.c"
				}
			}
		}
	}
}

void
layout_adjust_tree (Layout* self,
                    Node* parent,
                    gint child_index,
                    gint side_mask,
                    gdouble amount)
{
	LayoutClass* _klass_;
#line 125 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 125 "../src/Layout.vala"
	if (_klass_->adjust_tree) {
#line 125 "../src/Layout.vala"
		_klass_->adjust_tree (self, parent, child_index, side_mask, amount);
#line 1505 "Layout.c"
	}
}

static void
layout_real_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* p,
                             gdouble amount,
                             const gchar* msg)
{
	Node* parent = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* last = NULL;
	Node* _tmp3_;
	gint index = 0;
	GArray* nodes = NULL;
	DrawArea* _tmp4_;
	DrawArea* _tmp5_;
	GArray* _tmp6_;
	NodeBounds* prev = NULL;
	NodeBounds* _tmp7_;
#line 145 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 145 "../src/Layout.vala"
	g_return_if_fail (p != NULL);
#line 145 "../src/Layout.vala"
	g_return_if_fail (msg != NULL);
#line 147 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 147 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 147 "../src/Layout.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 147 "../src/Layout.vala"
	parent = _tmp2_;
#line 148 "../src/Layout.vala"
	_tmp3_ = _g_object_ref0 (n);
#line 148 "../src/Layout.vala"
	last = _tmp3_;
#line 149 "../src/Layout.vala"
	index = node_index (n);
#line 150 "../src/Layout.vala"
	_tmp4_ = node_get_da (n);
#line 150 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 150 "../src/Layout.vala"
	_tmp6_ = draw_area_get_nodes (_tmp5_);
#line 150 "../src/Layout.vala"
	nodes = _tmp6_;
#line 151 "../src/Layout.vala"
	_tmp7_ = node_bounds_new_copy (p);
#line 151 "../src/Layout.vala"
	prev = _tmp7_;
#line 153 "../src/Layout.vala"
	while (TRUE) {
#line 1563 "Layout.c"
		Node* _tmp8_;
		Node* _tmp9_;
		NodeSide _tmp10_;
		NodeSide _tmp11_;
		NodeBounds* _tmp12_;
		Node* _tmp13_;
		NodeBounds* _tmp14_;
		NodeBounds* _tmp15_;
		Node* _tmp16_;
		Node* _tmp17_;
		Node* _tmp18_;
		Node* _tmp19_;
		Node* _tmp20_;
		Node* _tmp21_;
		Node* _tmp22_;
		Node* _tmp23_;
#line 153 "../src/Layout.vala"
		_tmp8_ = parent;
#line 153 "../src/Layout.vala"
		if (!(_tmp8_ != NULL)) {
#line 153 "../src/Layout.vala"
			break;
#line 1586 "Layout.c"
		}
#line 154 "../src/Layout.vala"
		_tmp9_ = parent;
#line 154 "../src/Layout.vala"
		_tmp10_ = node_get_side (n);
#line 154 "../src/Layout.vala"
		_tmp11_ = _tmp10_;
#line 154 "../src/Layout.vala"
		layout_adjust_tree (self, _tmp9_, index, (gint) _tmp11_, amount);
#line 155 "../src/Layout.vala"
		_tmp12_ = prev;
#line 155 "../src/Layout.vala"
		_tmp13_ = parent;
#line 155 "../src/Layout.vala"
		_tmp14_ = node_get_tree_bbox (_tmp13_);
#line 155 "../src/Layout.vala"
		_tmp15_ = _tmp14_;
#line 155 "../src/Layout.vala"
		node_bounds_copy_from (_tmp12_, _tmp15_);
#line 156 "../src/Layout.vala"
		_tmp16_ = parent;
#line 156 "../src/Layout.vala"
		amount = 0 - (layout_get_adjust (self, _tmp16_) / 2);
#line 157 "../src/Layout.vala"
		_tmp17_ = parent;
#line 157 "../src/Layout.vala"
		index = node_index (_tmp17_);
#line 158 "../src/Layout.vala"
		_tmp18_ = parent;
#line 158 "../src/Layout.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 158 "../src/Layout.vala"
		_g_object_unref0 (last);
#line 158 "../src/Layout.vala"
		last = _tmp19_;
#line 159 "../src/Layout.vala"
		_tmp20_ = parent;
#line 159 "../src/Layout.vala"
		_tmp21_ = node_get_parent (_tmp20_);
#line 159 "../src/Layout.vala"
		_tmp22_ = _tmp21_;
#line 159 "../src/Layout.vala"
		_tmp23_ = _g_object_ref0 (_tmp22_);
#line 159 "../src/Layout.vala"
		_g_object_unref0 (parent);
#line 159 "../src/Layout.vala"
		parent = _tmp23_;
#line 1634 "Layout.c"
	}
	{
		gint i = 0;
#line 162 "../src/Layout.vala"
		i = 0;
#line 1640 "Layout.c"
		{
			gboolean _tmp24_ = FALSE;
#line 162 "../src/Layout.vala"
			_tmp24_ = TRUE;
#line 162 "../src/Layout.vala"
			while (TRUE) {
#line 1647 "Layout.c"
				GArray* _tmp26_;
				GArray* _tmp27_;
				Node* _tmp28_;
				Node* _tmp29_;
#line 162 "../src/Layout.vala"
				if (!_tmp24_) {
#line 1654 "Layout.c"
					gint _tmp25_;
#line 162 "../src/Layout.vala"
					_tmp25_ = i;
#line 162 "../src/Layout.vala"
					i = _tmp25_ + 1;
#line 1660 "Layout.c"
				}
#line 162 "../src/Layout.vala"
				_tmp24_ = FALSE;
#line 162 "../src/Layout.vala"
				_tmp26_ = nodes;
#line 162 "../src/Layout.vala"
				if (!(((guint) i) < _tmp26_->len)) {
#line 162 "../src/Layout.vala"
					break;
#line 1670 "Layout.c"
				}
#line 163 "../src/Layout.vala"
				_tmp27_ = nodes;
#line 163 "../src/Layout.vala"
				_tmp28_ = g_array_index (_tmp27_, Node*, (guint) i);
#line 163 "../src/Layout.vala"
				_tmp29_ = last;
#line 163 "../src/Layout.vala"
				if (_tmp28_ == _tmp29_) {
#line 1680 "Layout.c"
					DrawArea* _tmp30_;
					DrawArea* _tmp31_;
					NodeBounds* _tmp32_;
#line 164 "../src/Layout.vala"
					_tmp30_ = node_get_da (n);
#line 164 "../src/Layout.vala"
					_tmp31_ = _tmp30_;
#line 164 "../src/Layout.vala"
					_tmp32_ = prev;
#line 164 "../src/Layout.vala"
					draw_area_handle_tree_overlap (_tmp31_, _tmp32_);
#line 1692 "Layout.c"
				}
			}
		}
	}
#line 145 "../src/Layout.vala"
	_node_bounds_unref0 (prev);
#line 145 "../src/Layout.vala"
	_g_array_unref0 (nodes);
#line 145 "../src/Layout.vala"
	_g_object_unref0 (last);
#line 145 "../src/Layout.vala"
	_g_object_unref0 (parent);
#line 1705 "Layout.c"
}

void
layout_adjust_tree_all (Layout* self,
                        Node* n,
                        NodeBounds* p,
                        gdouble amount,
                        const gchar* msg)
{
	LayoutClass* _klass_;
#line 145 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 145 "../src/Layout.vala"
	if (_klass_->adjust_tree_all) {
#line 145 "../src/Layout.vala"
		_klass_->adjust_tree_all (self, n, p, amount, msg);
#line 1724 "Layout.c"
	}
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 174 "../src/Layout.vala"
	dup = g_new0 (gint, 1);
#line 174 "../src/Layout.vala"
	memcpy (dup, self, sizeof (gint));
#line 174 "../src/Layout.vala"
	return dup;
#line 1738 "Layout.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 174 "../src/Layout.vala"
	return self ? _int_dup (self) : NULL;
#line 1746 "Layout.c"
}

static void
layout_real_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Style* _tmp0_;
	Style* _tmp1_;
	gint* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
#line 171 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 174 "../src/Layout.vala"
	_tmp0_ = node_get_style (parent);
#line 174 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 174 "../src/Layout.vala"
	_tmp2_ = style_get_branch_margin (_tmp1_);
#line 174 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/Layout.vala"
	_tmp4_ = __int_dup0 (_tmp3_);
#line 174 "../src/Layout.vala"
	margin = _tmp4_;
#line 176 "../src/Layout.vala"
	node_bbox (parent, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_);
#line 176 "../src/Layout.vala"
	px = _tmp5_;
#line 176 "../src/Layout.vala"
	py = _tmp6_;
#line 176 "../src/Layout.vala"
	pw = _tmp7_;
#line 176 "../src/Layout.vala"
	ph = _tmp8_;
#line 1792 "Layout.c"
	{
		gint i = 0;
#line 178 "../src/Layout.vala"
		i = 0;
#line 1797 "Layout.c"
		{
			gboolean _tmp9_ = FALSE;
#line 178 "../src/Layout.vala"
			_tmp9_ = TRUE;
#line 178 "../src/Layout.vala"
			while (TRUE) {
#line 1804 "Layout.c"
				GArray* _tmp11_;
				GArray* _tmp12_;
				gboolean _tmp13_;
				Node* n = NULL;
				GArray* _tmp14_;
				GArray* _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
				Node* _tmp18_;
				Node* _tmp19_;
				NodeSide _tmp20_;
				NodeSide _tmp21_;
#line 178 "../src/Layout.vala"
				if (!_tmp9_) {
#line 1819 "Layout.c"
					gint _tmp10_;
#line 178 "../src/Layout.vala"
					_tmp10_ = i;
#line 178 "../src/Layout.vala"
					i = _tmp10_ + 1;
#line 1825 "Layout.c"
				}
#line 178 "../src/Layout.vala"
				_tmp9_ = FALSE;
#line 178 "../src/Layout.vala"
				_tmp11_ = node_children (parent);
#line 178 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 178 "../src/Layout.vala"
				_tmp13_ = !(((guint) i) < _tmp12_->len);
#line 178 "../src/Layout.vala"
				_g_array_unref0 (_tmp12_);
#line 178 "../src/Layout.vala"
				if (_tmp13_) {
#line 178 "../src/Layout.vala"
					break;
#line 1841 "Layout.c"
				}
#line 179 "../src/Layout.vala"
				_tmp14_ = node_children (parent);
#line 179 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 179 "../src/Layout.vala"
				_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
#line 179 "../src/Layout.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 179 "../src/Layout.vala"
				_tmp18_ = _tmp17_;
#line 179 "../src/Layout.vala"
				_g_array_unref0 (_tmp15_);
#line 179 "../src/Layout.vala"
				n = _tmp18_;
#line 180 "../src/Layout.vala"
				_tmp19_ = n;
#line 180 "../src/Layout.vala"
				_tmp20_ = node_get_side (_tmp19_);
#line 180 "../src/Layout.vala"
				_tmp21_ = _tmp20_;
#line 180 "../src/Layout.vala"
				if (_tmp21_ != side) {
#line 1865 "Layout.c"
					Node* _tmp22_;
					Node* _tmp41_;
#line 181 "../src/Layout.vala"
					_tmp22_ = n;
#line 181 "../src/Layout.vala"
					node_set_side (_tmp22_, side);
#line 182 "../src/Layout.vala"
					switch (side) {
#line 182 "../src/Layout.vala"
						case NODE_SIDE_LEFT:
#line 1876 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp23_;
							gdouble _tmp24_ = 0.0;
							gdouble _tmp25_ = 0.0;
							gdouble _tmp26_ = 0.0;
							gdouble _tmp27_ = 0.0;
							Node* _tmp28_;
							gint* _tmp29_;
#line 185 "../src/Layout.vala"
							_tmp23_ = n;
#line 185 "../src/Layout.vala"
							node_bbox (_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
#line 185 "../src/Layout.vala"
							cx = _tmp24_;
#line 185 "../src/Layout.vala"
							cy = _tmp25_;
#line 185 "../src/Layout.vala"
							cw = _tmp26_;
#line 185 "../src/Layout.vala"
							ch = _tmp27_;
#line 186 "../src/Layout.vala"
							_tmp28_ = n;
#line 186 "../src/Layout.vala"
							_tmp29_ = margin;
#line 186 "../src/Layout.vala"
							node_set_posx (_tmp28_, (px - (*_tmp29_)) - cw);
#line 187 "../src/Layout.vala"
							break;
#line 1909 "Layout.c"
						}
#line 182 "../src/Layout.vala"
						case NODE_SIDE_RIGHT:
#line 1913 "Layout.c"
						{
							Node* _tmp30_;
							gint* _tmp31_;
#line 189 "../src/Layout.vala"
							_tmp30_ = n;
#line 189 "../src/Layout.vala"
							_tmp31_ = margin;
#line 189 "../src/Layout.vala"
							node_set_posx (_tmp30_, (px + pw) + (*_tmp31_));
#line 190 "../src/Layout.vala"
							break;
#line 1925 "Layout.c"
						}
#line 182 "../src/Layout.vala"
						case NODE_SIDE_TOP:
#line 1929 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp32_;
							gdouble _tmp33_ = 0.0;
							gdouble _tmp34_ = 0.0;
							gdouble _tmp35_ = 0.0;
							gdouble _tmp36_ = 0.0;
							Node* _tmp37_;
							gint* _tmp38_;
#line 193 "../src/Layout.vala"
							_tmp32_ = n;
#line 193 "../src/Layout.vala"
							node_bbox (_tmp32_, &_tmp33_, &_tmp34_, &_tmp35_, &_tmp36_);
#line 193 "../src/Layout.vala"
							cx = _tmp33_;
#line 193 "../src/Layout.vala"
							cy = _tmp34_;
#line 193 "../src/Layout.vala"
							cw = _tmp35_;
#line 193 "../src/Layout.vala"
							ch = _tmp36_;
#line 194 "../src/Layout.vala"
							_tmp37_ = n;
#line 194 "../src/Layout.vala"
							_tmp38_ = margin;
#line 194 "../src/Layout.vala"
							node_set_posy (_tmp37_, (py - (*_tmp38_)) - ch);
#line 195 "../src/Layout.vala"
							break;
#line 1962 "Layout.c"
						}
#line 182 "../src/Layout.vala"
						case NODE_SIDE_BOTTOM:
#line 1966 "Layout.c"
						{
							Node* _tmp39_;
							gint* _tmp40_;
#line 197 "../src/Layout.vala"
							_tmp39_ = n;
#line 197 "../src/Layout.vala"
							_tmp40_ = margin;
#line 197 "../src/Layout.vala"
							node_set_posy (_tmp39_, (py + ph) + (*_tmp40_));
#line 198 "../src/Layout.vala"
							break;
#line 1978 "Layout.c"
						}
						default:
#line 182 "../src/Layout.vala"
						break;
#line 1983 "Layout.c"
					}
#line 200 "../src/Layout.vala"
					_tmp41_ = n;
#line 200 "../src/Layout.vala"
					layout_propagate_side (self, _tmp41_, side);
#line 1989 "Layout.c"
				}
#line 178 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 1993 "Layout.c"
			}
		}
	}
#line 171 "../src/Layout.vala"
	_g_free0 (margin);
#line 1999 "Layout.c"
}

void
layout_propagate_side (Layout* self,
                       Node* parent,
                       NodeSide side)
{
	LayoutClass* _klass_;
#line 171 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 171 "../src/Layout.vala"
	if (_klass_->propagate_side) {
#line 171 "../src/Layout.vala"
		_klass_->propagate_side (self, parent, side);
#line 2016 "Layout.c"
	}
}

static NodeSide
layout_real_get_side (Layout* self,
                      Node* n)
{
	gdouble rx = 0.0;
	gdouble ry = 0.0;
	gdouble rw = 0.0;
	gdouble rh = 0.0;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
	NodeSide result;
#line 207 "../src/Layout.vala"
	g_return_val_if_fail (n != NULL, 0);
#line 210 "../src/Layout.vala"
	_tmp0_ = node_get_root (n);
#line 210 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 210 "../src/Layout.vala"
	rx = _tmp2_;
#line 210 "../src/Layout.vala"
	ry = _tmp3_;
#line 210 "../src/Layout.vala"
	rw = _tmp4_;
#line 210 "../src/Layout.vala"
	rh = _tmp5_;
#line 210 "../src/Layout.vala"
	_g_object_unref0 (_tmp1_);
#line 211 "../src/Layout.vala"
	node_bbox (n, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 211 "../src/Layout.vala"
	nx = _tmp6_;
#line 211 "../src/Layout.vala"
	ny = _tmp7_;
#line 211 "../src/Layout.vala"
	nw = _tmp8_;
#line 211 "../src/Layout.vala"
	nh = _tmp9_;
#line 212 "../src/Layout.vala"
	_tmp10_ = node_get_side (n);
#line 212 "../src/Layout.vala"
	_tmp11_ = _tmp10_;
#line 212 "../src/Layout.vala"
	if ((_tmp11_ & node_side_horizontal ()) != 0) {
#line 2079 "Layout.c"
		NodeSide _tmp12_ = 0;
#line 213 "../src/Layout.vala"
		if ((nx + (nw / 2)) > (rx + (rw / 2))) {
#line 213 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_RIGHT;
#line 2085 "Layout.c"
		} else {
#line 213 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_LEFT;
#line 2089 "Layout.c"
		}
#line 213 "../src/Layout.vala"
		result = _tmp12_;
#line 213 "../src/Layout.vala"
		return result;
#line 2095 "Layout.c"
	} else {
		NodeSide _tmp13_ = 0;
#line 215 "../src/Layout.vala"
		if ((ny + (nh / 2)) > (ry + (rh / 2))) {
#line 215 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_BOTTOM;
#line 2102 "Layout.c"
		} else {
#line 215 "../src/Layout.vala"
			_tmp13_ = NODE_SIDE_TOP;
#line 2106 "Layout.c"
		}
#line 215 "../src/Layout.vala"
		result = _tmp13_;
#line 215 "../src/Layout.vala"
		return result;
#line 2112 "Layout.c"
	}
}

NodeSide
layout_get_side (Layout* self,
                 Node* n)
{
	LayoutClass* _klass_;
#line 207 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 207 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 207 "../src/Layout.vala"
	if (_klass_->get_side) {
#line 207 "../src/Layout.vala"
		return _klass_->get_side (self, n);
#line 2129 "Layout.c"
	}
#line 207 "../src/Layout.vala"
	return 0;
#line 2133 "Layout.c"
}

static void
layout_real_set_side (Layout* self,
                      Node* current)
{
#line 220 "../src/Layout.vala"
	g_return_if_fail (current != NULL);
#line 221 "../src/Layout.vala"
	if (!node_is_root (current)) {
#line 2144 "Layout.c"
		NodeSide side = 0;
		NodeSide _tmp0_;
		NodeSide _tmp1_;
#line 222 "../src/Layout.vala"
		side = layout_get_side (self, current);
#line 223 "../src/Layout.vala"
		_tmp0_ = node_get_side (current);
#line 223 "../src/Layout.vala"
		_tmp1_ = _tmp0_;
#line 223 "../src/Layout.vala"
		if (_tmp1_ != side) {
#line 224 "../src/Layout.vala"
			node_set_side (current, side);
#line 225 "../src/Layout.vala"
			layout_propagate_side (self, current, side);
#line 2160 "Layout.c"
		}
	}
}

void
layout_set_side (Layout* self,
                 Node* current)
{
	LayoutClass* _klass_;
#line 220 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 220 "../src/Layout.vala"
	if (_klass_->set_side) {
#line 220 "../src/Layout.vala"
		_klass_->set_side (self, current);
#line 2178 "Layout.c"
	}
}

void
layout_apply_margin (Layout* self,
                     Node* n)
{
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Node* _tmp2_;
	Node* _tmp3_;
	Style* _tmp4_;
	Style* _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gint* _tmp8_;
	Node* _tmp9_;
	Node* _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	NodeSide _tmp15_;
	NodeSide _tmp16_;
#line 231 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 232 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 232 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 232 "../src/Layout.vala"
	if (_tmp1_ == NULL) {
#line 232 "../src/Layout.vala"
		return;
#line 2220 "Layout.c"
	}
#line 234 "../src/Layout.vala"
	_tmp2_ = node_get_parent (n);
#line 234 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 234 "../src/Layout.vala"
	_tmp4_ = node_get_style (_tmp3_);
#line 234 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 234 "../src/Layout.vala"
	_tmp6_ = style_get_branch_margin (_tmp5_);
#line 234 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 234 "../src/Layout.vala"
	_tmp8_ = __int_dup0 (_tmp7_);
#line 234 "../src/Layout.vala"
	margin = _tmp8_;
#line 235 "../src/Layout.vala"
	_tmp9_ = node_get_parent (n);
#line 235 "../src/Layout.vala"
	_tmp10_ = _tmp9_;
#line 235 "../src/Layout.vala"
	node_bbox (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 235 "../src/Layout.vala"
	px = _tmp11_;
#line 235 "../src/Layout.vala"
	py = _tmp12_;
#line 235 "../src/Layout.vala"
	pw = _tmp13_;
#line 235 "../src/Layout.vala"
	ph = _tmp14_;
#line 236 "../src/Layout.vala"
	_tmp15_ = node_get_side (n);
#line 236 "../src/Layout.vala"
	_tmp16_ = _tmp15_;
#line 236 "../src/Layout.vala"
	switch (_tmp16_) {
#line 236 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 2260 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp17_ = 0.0;
			gdouble _tmp18_ = 0.0;
			gdouble _tmp19_ = 0.0;
			gdouble _tmp20_ = 0.0;
			gint* _tmp21_;
#line 239 "../src/Layout.vala"
			node_bbox (n, &_tmp17_, &_tmp18_, &_tmp19_, &_tmp20_);
#line 239 "../src/Layout.vala"
			cx = _tmp17_;
#line 239 "../src/Layout.vala"
			cy = _tmp18_;
#line 239 "../src/Layout.vala"
			cw = _tmp19_;
#line 239 "../src/Layout.vala"
			ch = _tmp20_;
#line 240 "../src/Layout.vala"
			_tmp21_ = margin;
#line 240 "../src/Layout.vala"
			node_set_posx (n, px - (cw + (*_tmp21_)));
#line 241 "../src/Layout.vala"
			break;
#line 2287 "Layout.c"
		}
#line 236 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 2291 "Layout.c"
		{
			gint* _tmp22_;
			Node* _tmp23_;
			Node* _tmp24_;
#line 243 "../src/Layout.vala"
			_tmp22_ = margin;
#line 243 "../src/Layout.vala"
			_tmp23_ = node_get_parent (n);
#line 243 "../src/Layout.vala"
			_tmp24_ = _tmp23_;
#line 243 "../src/Layout.vala"
			node_set_posx (n, (px + (pw + (*_tmp22_))) - node_task_width (_tmp24_));
#line 244 "../src/Layout.vala"
			break;
#line 2306 "Layout.c"
		}
#line 236 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 2310 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp25_ = 0.0;
			gdouble _tmp26_ = 0.0;
			gdouble _tmp27_ = 0.0;
			gdouble _tmp28_ = 0.0;
			gint* _tmp29_;
#line 247 "../src/Layout.vala"
			node_bbox (n, &_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_);
#line 247 "../src/Layout.vala"
			cx = _tmp25_;
#line 247 "../src/Layout.vala"
			cy = _tmp26_;
#line 247 "../src/Layout.vala"
			cw = _tmp27_;
#line 247 "../src/Layout.vala"
			ch = _tmp28_;
#line 248 "../src/Layout.vala"
			_tmp29_ = margin;
#line 248 "../src/Layout.vala"
			node_set_posy (n, py - (ch + (*_tmp29_)));
#line 249 "../src/Layout.vala"
			break;
#line 2337 "Layout.c"
		}
#line 236 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 2341 "Layout.c"
		{
			gint* _tmp30_;
#line 251 "../src/Layout.vala"
			_tmp30_ = margin;
#line 251 "../src/Layout.vala"
			node_set_posy (n, py + (ph + (*_tmp30_)));
#line 252 "../src/Layout.vala"
			break;
#line 2350 "Layout.c"
		}
		default:
#line 236 "../src/Layout.vala"
		break;
#line 2355 "Layout.c"
	}
#line 231 "../src/Layout.vala"
	_g_free0 (margin);
#line 2359 "Layout.c"
}

static void
layout_real_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh)
{
	gdouble adjust = 0.0;
	NodeSide _tmp0_;
	NodeSide _tmp1_;
	NodeBounds* _tmp79_;
	NodeBounds* _tmp80_;
#line 257 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 258 "../src/Layout.vala"
	adjust = 0 - (layout_get_adjust (self, n) / 2);
#line 259 "../src/Layout.vala"
	_tmp0_ = node_get_side (n);
#line 259 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 259 "../src/Layout.vala"
	if ((_tmp1_ & node_side_horizontal ()) != 0) {
#line 260 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 261 "../src/Layout.vala"
			node_adjust_posy_only (n, 0 - (diffh / 2));
#line 2387 "Layout.c"
		}
#line 263 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 264 "../src/Layout.vala"
			if (node_is_root (n)) {
#line 265 "../src/Layout.vala"
				node_adjust_posx_only (n, 0 - (diffw / 2));
#line 2395 "Layout.c"
				{
					gint i = 0;
#line 266 "../src/Layout.vala"
					i = 0;
#line 2400 "Layout.c"
					{
						gboolean _tmp2_ = FALSE;
#line 266 "../src/Layout.vala"
						_tmp2_ = TRUE;
#line 266 "../src/Layout.vala"
						while (TRUE) {
#line 2407 "Layout.c"
							GArray* _tmp4_;
							GArray* _tmp5_;
							gboolean _tmp6_;
							Node* child = NULL;
							GArray* _tmp7_;
							GArray* _tmp8_;
							Node* _tmp9_;
							Node* _tmp10_;
							Node* _tmp11_;
							Node* _tmp12_;
							NodeSide _tmp13_;
							NodeSide _tmp14_;
#line 266 "../src/Layout.vala"
							if (!_tmp2_) {
#line 2422 "Layout.c"
								gint _tmp3_;
#line 266 "../src/Layout.vala"
								_tmp3_ = i;
#line 266 "../src/Layout.vala"
								i = _tmp3_ + 1;
#line 2428 "Layout.c"
							}
#line 266 "../src/Layout.vala"
							_tmp2_ = FALSE;
#line 266 "../src/Layout.vala"
							_tmp4_ = node_children (n);
#line 266 "../src/Layout.vala"
							_tmp5_ = _tmp4_;
#line 266 "../src/Layout.vala"
							_tmp6_ = !(((guint) i) < _tmp5_->len);
#line 266 "../src/Layout.vala"
							_g_array_unref0 (_tmp5_);
#line 266 "../src/Layout.vala"
							if (_tmp6_) {
#line 266 "../src/Layout.vala"
								break;
#line 2444 "Layout.c"
							}
#line 267 "../src/Layout.vala"
							_tmp7_ = node_children (n);
#line 267 "../src/Layout.vala"
							_tmp8_ = _tmp7_;
#line 267 "../src/Layout.vala"
							_tmp9_ = g_array_index (_tmp8_, Node*, (guint) i);
#line 267 "../src/Layout.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 267 "../src/Layout.vala"
							_tmp11_ = _tmp10_;
#line 267 "../src/Layout.vala"
							_g_array_unref0 (_tmp8_);
#line 267 "../src/Layout.vala"
							child = _tmp11_;
#line 268 "../src/Layout.vala"
							_tmp12_ = child;
#line 268 "../src/Layout.vala"
							_tmp13_ = node_get_side (_tmp12_);
#line 268 "../src/Layout.vala"
							_tmp14_ = _tmp13_;
#line 268 "../src/Layout.vala"
							if (_tmp14_ == NODE_SIDE_LEFT) {
#line 2468 "Layout.c"
								Node* _tmp15_;
								Node* _tmp16_;
								gdouble _tmp17_;
								gdouble _tmp18_;
#line 269 "../src/Layout.vala"
								_tmp15_ = child;
#line 269 "../src/Layout.vala"
								_tmp16_ = child;
#line 269 "../src/Layout.vala"
								_tmp17_ = node_get_posx (_tmp16_);
#line 269 "../src/Layout.vala"
								_tmp18_ = _tmp17_;
#line 269 "../src/Layout.vala"
								node_set_posx (_tmp16_, _tmp18_ - (diffw / 2));
#line 2483 "Layout.c"
							} else {
								Node* _tmp19_;
								Node* _tmp20_;
								gdouble _tmp21_;
								gdouble _tmp22_;
#line 271 "../src/Layout.vala"
								_tmp19_ = child;
#line 271 "../src/Layout.vala"
								_tmp20_ = child;
#line 271 "../src/Layout.vala"
								_tmp21_ = node_get_posx (_tmp20_);
#line 271 "../src/Layout.vala"
								_tmp22_ = _tmp21_;
#line 271 "../src/Layout.vala"
								node_set_posx (_tmp20_, _tmp22_ + (diffw / 2));
#line 2499 "Layout.c"
							}
#line 266 "../src/Layout.vala"
							_g_object_unref0 (child);
#line 2503 "Layout.c"
						}
					}
				}
			} else {
				NodeSide _tmp23_;
				NodeSide _tmp24_;
#line 274 "../src/Layout.vala"
				_tmp23_ = node_get_side (n);
#line 274 "../src/Layout.vala"
				_tmp24_ = _tmp23_;
#line 274 "../src/Layout.vala"
				if (_tmp24_ == NODE_SIDE_LEFT) {
#line 2516 "Layout.c"
					gdouble _tmp25_;
					gdouble _tmp26_;
#line 275 "../src/Layout.vala"
					_tmp25_ = node_get_posx (n);
#line 275 "../src/Layout.vala"
					_tmp26_ = _tmp25_;
#line 275 "../src/Layout.vala"
					node_set_posx (n, _tmp26_ - diffw);
#line 2525 "Layout.c"
				} else {
					{
						gint i = 0;
#line 277 "../src/Layout.vala"
						i = 0;
#line 2531 "Layout.c"
						{
							gboolean _tmp27_ = FALSE;
#line 277 "../src/Layout.vala"
							_tmp27_ = TRUE;
#line 277 "../src/Layout.vala"
							while (TRUE) {
#line 2538 "Layout.c"
								GArray* _tmp29_;
								GArray* _tmp30_;
								gboolean _tmp31_;
								GArray* _tmp32_;
								GArray* _tmp33_;
								Node* _tmp34_;
								GArray* _tmp35_;
								GArray* _tmp36_;
								Node* _tmp37_;
								gdouble _tmp38_;
								gdouble _tmp39_;
#line 277 "../src/Layout.vala"
								if (!_tmp27_) {
#line 2552 "Layout.c"
									gint _tmp28_;
#line 277 "../src/Layout.vala"
									_tmp28_ = i;
#line 277 "../src/Layout.vala"
									i = _tmp28_ + 1;
#line 2558 "Layout.c"
								}
#line 277 "../src/Layout.vala"
								_tmp27_ = FALSE;
#line 277 "../src/Layout.vala"
								_tmp29_ = node_children (n);
#line 277 "../src/Layout.vala"
								_tmp30_ = _tmp29_;
#line 277 "../src/Layout.vala"
								_tmp31_ = !(((guint) i) < _tmp30_->len);
#line 277 "../src/Layout.vala"
								_g_array_unref0 (_tmp30_);
#line 277 "../src/Layout.vala"
								if (_tmp31_) {
#line 277 "../src/Layout.vala"
									break;
#line 2574 "Layout.c"
								}
#line 278 "../src/Layout.vala"
								_tmp32_ = node_children (n);
#line 278 "../src/Layout.vala"
								_tmp33_ = _tmp32_;
#line 278 "../src/Layout.vala"
								_tmp34_ = g_array_index (_tmp33_, Node*, (guint) i);
#line 278 "../src/Layout.vala"
								_tmp35_ = node_children (n);
#line 278 "../src/Layout.vala"
								_tmp36_ = _tmp35_;
#line 278 "../src/Layout.vala"
								_tmp37_ = g_array_index (_tmp36_, Node*, (guint) i);
#line 278 "../src/Layout.vala"
								_tmp38_ = node_get_posx (_tmp37_);
#line 278 "../src/Layout.vala"
								_tmp39_ = _tmp38_;
#line 278 "../src/Layout.vala"
								node_set_posx (_tmp37_, _tmp39_ + diffw);
#line 278 "../src/Layout.vala"
								_g_array_unref0 (_tmp36_);
#line 278 "../src/Layout.vala"
								_g_array_unref0 (_tmp33_);
#line 2598 "Layout.c"
							}
						}
					}
				}
			}
		}
	} else {
#line 283 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 284 "../src/Layout.vala"
			node_adjust_posx_only (n, 0 - (diffw / 2));
#line 2610 "Layout.c"
		}
#line 286 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 287 "../src/Layout.vala"
			if (node_is_root (n)) {
#line 2616 "Layout.c"
				gdouble _tmp40_;
				gdouble _tmp41_;
#line 288 "../src/Layout.vala"
				_tmp40_ = node_get_posy (n);
#line 288 "../src/Layout.vala"
				_tmp41_ = _tmp40_;
#line 288 "../src/Layout.vala"
				node_set_posy (n, _tmp41_ - (diffh / 2));
#line 2625 "Layout.c"
				{
					gint i = 0;
#line 289 "../src/Layout.vala"
					i = 0;
#line 2630 "Layout.c"
					{
						gboolean _tmp42_ = FALSE;
#line 289 "../src/Layout.vala"
						_tmp42_ = TRUE;
#line 289 "../src/Layout.vala"
						while (TRUE) {
#line 2637 "Layout.c"
							GArray* _tmp44_;
							GArray* _tmp45_;
							gboolean _tmp46_;
							Node* child = NULL;
							GArray* _tmp47_;
							GArray* _tmp48_;
							Node* _tmp49_;
							Node* _tmp50_;
							Node* _tmp51_;
							NodeSide _tmp52_;
							NodeSide _tmp53_;
#line 289 "../src/Layout.vala"
							if (!_tmp42_) {
#line 2651 "Layout.c"
								gint _tmp43_;
#line 289 "../src/Layout.vala"
								_tmp43_ = i;
#line 289 "../src/Layout.vala"
								i = _tmp43_ + 1;
#line 2657 "Layout.c"
							}
#line 289 "../src/Layout.vala"
							_tmp42_ = FALSE;
#line 289 "../src/Layout.vala"
							_tmp44_ = node_children (n);
#line 289 "../src/Layout.vala"
							_tmp45_ = _tmp44_;
#line 289 "../src/Layout.vala"
							_tmp46_ = !(((guint) i) < _tmp45_->len);
#line 289 "../src/Layout.vala"
							_g_array_unref0 (_tmp45_);
#line 289 "../src/Layout.vala"
							if (_tmp46_) {
#line 289 "../src/Layout.vala"
								break;
#line 2673 "Layout.c"
							}
#line 290 "../src/Layout.vala"
							_tmp47_ = node_children (n);
#line 290 "../src/Layout.vala"
							_tmp48_ = _tmp47_;
#line 290 "../src/Layout.vala"
							_tmp49_ = g_array_index (_tmp48_, Node*, (guint) i);
#line 290 "../src/Layout.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 290 "../src/Layout.vala"
							_tmp51_ = _tmp50_;
#line 290 "../src/Layout.vala"
							_g_array_unref0 (_tmp48_);
#line 290 "../src/Layout.vala"
							child = _tmp51_;
#line 291 "../src/Layout.vala"
							_tmp52_ = node_get_side (n);
#line 291 "../src/Layout.vala"
							_tmp53_ = _tmp52_;
#line 291 "../src/Layout.vala"
							if (_tmp53_ == NODE_SIDE_TOP) {
#line 2695 "Layout.c"
								Node* _tmp54_;
								Node* _tmp55_;
								gdouble _tmp56_;
								gdouble _tmp57_;
#line 292 "../src/Layout.vala"
								_tmp54_ = child;
#line 292 "../src/Layout.vala"
								_tmp55_ = child;
#line 292 "../src/Layout.vala"
								_tmp56_ = node_get_posy (_tmp55_);
#line 292 "../src/Layout.vala"
								_tmp57_ = _tmp56_;
#line 292 "../src/Layout.vala"
								node_set_posy (_tmp55_, _tmp57_ - (diffh / 2));
#line 2710 "Layout.c"
							} else {
								Node* _tmp58_;
								Node* _tmp59_;
								gdouble _tmp60_;
								gdouble _tmp61_;
#line 294 "../src/Layout.vala"
								_tmp58_ = child;
#line 294 "../src/Layout.vala"
								_tmp59_ = child;
#line 294 "../src/Layout.vala"
								_tmp60_ = node_get_posy (_tmp59_);
#line 294 "../src/Layout.vala"
								_tmp61_ = _tmp60_;
#line 294 "../src/Layout.vala"
								node_set_posy (_tmp59_, _tmp61_ + (diffh / 2));
#line 2726 "Layout.c"
							}
#line 289 "../src/Layout.vala"
							_g_object_unref0 (child);
#line 2730 "Layout.c"
						}
					}
				}
			} else {
				NodeSide _tmp62_;
				NodeSide _tmp63_;
#line 297 "../src/Layout.vala"
				_tmp62_ = node_get_side (n);
#line 297 "../src/Layout.vala"
				_tmp63_ = _tmp62_;
#line 297 "../src/Layout.vala"
				if (_tmp63_ == NODE_SIDE_TOP) {
#line 2743 "Layout.c"
					gdouble _tmp64_;
					gdouble _tmp65_;
#line 298 "../src/Layout.vala"
					_tmp64_ = node_get_posy (n);
#line 298 "../src/Layout.vala"
					_tmp65_ = _tmp64_;
#line 298 "../src/Layout.vala"
					node_set_posy (n, _tmp65_ - diffh);
#line 2752 "Layout.c"
				} else {
					{
						gint i = 0;
#line 300 "../src/Layout.vala"
						i = 0;
#line 2758 "Layout.c"
						{
							gboolean _tmp66_ = FALSE;
#line 300 "../src/Layout.vala"
							_tmp66_ = TRUE;
#line 300 "../src/Layout.vala"
							while (TRUE) {
#line 2765 "Layout.c"
								GArray* _tmp68_;
								GArray* _tmp69_;
								gboolean _tmp70_;
								GArray* _tmp71_;
								GArray* _tmp72_;
								Node* _tmp73_;
								GArray* _tmp74_;
								GArray* _tmp75_;
								Node* _tmp76_;
								gdouble _tmp77_;
								gdouble _tmp78_;
#line 300 "../src/Layout.vala"
								if (!_tmp66_) {
#line 2779 "Layout.c"
									gint _tmp67_;
#line 300 "../src/Layout.vala"
									_tmp67_ = i;
#line 300 "../src/Layout.vala"
									i = _tmp67_ + 1;
#line 2785 "Layout.c"
								}
#line 300 "../src/Layout.vala"
								_tmp66_ = FALSE;
#line 300 "../src/Layout.vala"
								_tmp68_ = node_children (n);
#line 300 "../src/Layout.vala"
								_tmp69_ = _tmp68_;
#line 300 "../src/Layout.vala"
								_tmp70_ = !(((guint) i) < _tmp69_->len);
#line 300 "../src/Layout.vala"
								_g_array_unref0 (_tmp69_);
#line 300 "../src/Layout.vala"
								if (_tmp70_) {
#line 300 "../src/Layout.vala"
									break;
#line 2801 "Layout.c"
								}
#line 301 "../src/Layout.vala"
								_tmp71_ = node_children (n);
#line 301 "../src/Layout.vala"
								_tmp72_ = _tmp71_;
#line 301 "../src/Layout.vala"
								_tmp73_ = g_array_index (_tmp72_, Node*, (guint) i);
#line 301 "../src/Layout.vala"
								_tmp74_ = node_children (n);
#line 301 "../src/Layout.vala"
								_tmp75_ = _tmp74_;
#line 301 "../src/Layout.vala"
								_tmp76_ = g_array_index (_tmp75_, Node*, (guint) i);
#line 301 "../src/Layout.vala"
								_tmp77_ = node_get_posy (_tmp76_);
#line 301 "../src/Layout.vala"
								_tmp78_ = _tmp77_;
#line 301 "../src/Layout.vala"
								node_set_posy (_tmp76_, _tmp78_ + diffh);
#line 301 "../src/Layout.vala"
								_g_array_unref0 (_tmp75_);
#line 301 "../src/Layout.vala"
								_g_array_unref0 (_tmp72_);
#line 2825 "Layout.c"
							}
						}
					}
				}
			}
		}
	}
#line 306 "../src/Layout.vala"
	_tmp79_ = node_get_tree_bbox (n);
#line 306 "../src/Layout.vala"
	_tmp80_ = _tmp79_;
#line 306 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, _tmp80_, adjust, "by_edit");
#line 2839 "Layout.c"
}

void
layout_handle_update_by_edit (Layout* self,
                              Node* n,
                              gdouble diffw,
                              gdouble diffh)
{
	LayoutClass* _klass_;
#line 257 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 257 "../src/Layout.vala"
	if (_klass_->handle_update_by_edit) {
#line 257 "../src/Layout.vala"
		_klass_->handle_update_by_edit (self, n, diffw, diffh);
#line 2857 "Layout.c"
	}
}

static void
layout_real_handle_update_by_fold (Layout* self,
                                   Node* n)
{
	NodeBounds* _tmp0_;
	NodeBounds* _tmp1_;
#line 310 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 311 "../src/Layout.vala"
	_tmp0_ = node_get_tree_bbox (n);
#line 311 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 311 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, _tmp1_, 0 - (layout_get_adjust (self, n) / 2), "by_fold");
#line 2875 "Layout.c"
}

void
layout_handle_update_by_fold (Layout* self,
                              Node* n)
{
	LayoutClass* _klass_;
#line 310 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 310 "../src/Layout.vala"
	if (_klass_->handle_update_by_fold) {
#line 310 "../src/Layout.vala"
		_klass_->handle_update_by_fold (self, n);
#line 2891 "Layout.c"
	}
}

static gdouble
layout_real_get_insert_adjust (Layout* self,
                               Node* child)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble result;
#line 315 "../src/Layout.vala"
	g_return_val_if_fail (child != NULL, 0.0);
#line 316 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (child);
#line 316 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 316 "../src/Layout.vala"
	result = _tmp1_ / 2;
#line 316 "../src/Layout.vala"
	return result;
#line 2912 "Layout.c"
}

gdouble
layout_get_insert_adjust (Layout* self,
                          Node* child)
{
	LayoutClass* _klass_;
#line 315 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 315 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 315 "../src/Layout.vala"
	if (_klass_->get_insert_adjust) {
#line 315 "../src/Layout.vala"
		return _klass_->get_insert_adjust (self, child);
#line 2928 "Layout.c"
	}
#line 315 "../src/Layout.vala"
	return -1.0;
#line 2932 "Layout.c"
}

static void
layout_real_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos)
{
	gdouble ox = 0.0;
	gdouble oy = 0.0;
	gdouble ow = 0.0;
	gdouble oh = 0.0;
	gdouble adjust = 0.0;
	NodeBounds* cb = NULL;
	NodeBounds* _tmp0_;
	NodeBounds* _tmp1_;
	NodeBounds* _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	NodeSide _tmp7_;
	NodeSide _tmp8_;
	NodeBounds* _tmp74_;
	NodeBounds* _tmp75_;
#line 320 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 320 "../src/Layout.vala"
	g_return_if_fail (child != NULL);
#line 325 "../src/Layout.vala"
	layout_update_tree_size (self, child);
#line 327 "../src/Layout.vala"
	_tmp0_ = node_get_tree_bbox (child);
#line 327 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 327 "../src/Layout.vala"
	_tmp2_ = _node_bounds_ref0 (_tmp1_);
#line 327 "../src/Layout.vala"
	cb = _tmp2_;
#line 329 "../src/Layout.vala"
	node_bbox (child, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 329 "../src/Layout.vala"
	ox = _tmp3_;
#line 329 "../src/Layout.vala"
	oy = _tmp4_;
#line 329 "../src/Layout.vala"
	ow = _tmp5_;
#line 329 "../src/Layout.vala"
	oh = _tmp6_;
#line 330 "../src/Layout.vala"
	layout_apply_margin (self, child);
#line 331 "../src/Layout.vala"
	adjust = layout_get_insert_adjust (self, child);
#line 337 "../src/Layout.vala"
	_tmp7_ = node_get_side (child);
#line 337 "../src/Layout.vala"
	_tmp8_ = _tmp7_;
#line 337 "../src/Layout.vala"
	if (node_side_count (parent, _tmp8_) == 1) {
#line 2992 "Layout.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble pw = 0.0;
		gdouble ph = 0.0;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		NodeSide _tmp13_;
		NodeSide _tmp14_;
#line 339 "../src/Layout.vala"
		node_bbox (parent, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 339 "../src/Layout.vala"
		px = _tmp9_;
#line 339 "../src/Layout.vala"
		py = _tmp10_;
#line 339 "../src/Layout.vala"
		pw = _tmp11_;
#line 339 "../src/Layout.vala"
		ph = _tmp12_;
#line 340 "../src/Layout.vala"
		_tmp13_ = node_get_side (child);
#line 340 "../src/Layout.vala"
		_tmp14_ = _tmp13_;
#line 340 "../src/Layout.vala"
		if ((_tmp14_ & node_side_horizontal ()) != 0) {
#line 341 "../src/Layout.vala"
			node_set_posy (child, py + ((ph / 2) - (oh / 2)));
#line 3021 "Layout.c"
		} else {
#line 343 "../src/Layout.vala"
			node_set_posx (child, px + ((pw / 2) - (ow / 2)));
#line 3025 "Layout.c"
		}
	} else {
		gboolean _tmp15_ = FALSE;
		GArray* _tmp16_;
		GArray* _tmp17_;
		gboolean _tmp18_;
#line 350 "../src/Layout.vala"
		_tmp16_ = node_children (parent);
#line 350 "../src/Layout.vala"
		_tmp17_ = _tmp16_;
#line 350 "../src/Layout.vala"
		_tmp18_ = ((guint) (pos + 1)) == _tmp17_->len;
#line 350 "../src/Layout.vala"
		_g_array_unref0 (_tmp17_);
#line 350 "../src/Layout.vala"
		if (_tmp18_) {
#line 350 "../src/Layout.vala"
			_tmp15_ = TRUE;
#line 3044 "Layout.c"
		} else {
			GArray* _tmp19_;
			GArray* _tmp20_;
			Node* _tmp21_;
			NodeSide _tmp22_;
			NodeSide _tmp23_;
			NodeSide _tmp24_;
			NodeSide _tmp25_;
#line 350 "../src/Layout.vala"
			_tmp19_ = node_children (parent);
#line 350 "../src/Layout.vala"
			_tmp20_ = _tmp19_;
#line 350 "../src/Layout.vala"
			_tmp21_ = g_array_index (_tmp20_, Node*, (guint) (pos + 1));
#line 350 "../src/Layout.vala"
			_tmp22_ = node_get_side (_tmp21_);
#line 350 "../src/Layout.vala"
			_tmp23_ = _tmp22_;
#line 350 "../src/Layout.vala"
			_tmp24_ = node_get_side (child);
#line 350 "../src/Layout.vala"
			_tmp25_ = _tmp24_;
#line 350 "../src/Layout.vala"
			_tmp15_ = _tmp23_ != _tmp25_;
#line 350 "../src/Layout.vala"
			_g_array_unref0 (_tmp20_);
#line 3071 "Layout.c"
		}
#line 350 "../src/Layout.vala"
		if (_tmp15_) {
#line 3075 "Layout.c"
			NodeBounds* sb = NULL;
			GArray* _tmp26_;
			GArray* _tmp27_;
			Node* _tmp28_;
			NodeSide _tmp29_;
			NodeSide _tmp30_;
			NodeBounds* _tmp31_;
			NodeBounds* _tmp32_;
			NodeSide _tmp33_;
			NodeSide _tmp34_;
#line 351 "../src/Layout.vala"
			_tmp26_ = node_children (parent);
#line 351 "../src/Layout.vala"
			_tmp27_ = _tmp26_;
#line 351 "../src/Layout.vala"
			_tmp28_ = g_array_index (_tmp27_, Node*, (guint) (pos - 1));
#line 351 "../src/Layout.vala"
			_tmp29_ = node_get_side (child);
#line 351 "../src/Layout.vala"
			_tmp30_ = _tmp29_;
#line 351 "../src/Layout.vala"
			_tmp31_ = layout_bbox (self, _tmp28_, (gint) _tmp30_);
#line 351 "../src/Layout.vala"
			_tmp32_ = _tmp31_;
#line 351 "../src/Layout.vala"
			_g_array_unref0 (_tmp27_);
#line 351 "../src/Layout.vala"
			sb = _tmp32_;
#line 352 "../src/Layout.vala"
			_tmp33_ = node_get_side (child);
#line 352 "../src/Layout.vala"
			_tmp34_ = _tmp33_;
#line 352 "../src/Layout.vala"
			if ((_tmp34_ & node_side_horizontal ()) != 0) {
#line 3110 "Layout.c"
				NodeBounds* _tmp35_;
				gdouble _tmp36_;
				gdouble _tmp37_;
				NodeBounds* _tmp38_;
				gdouble _tmp39_;
				gdouble _tmp40_;
				NodeBounds* _tmp41_;
				gdouble _tmp42_;
				gdouble _tmp43_;
#line 353 "../src/Layout.vala"
				_tmp35_ = sb;
#line 353 "../src/Layout.vala"
				_tmp36_ = node_bounds_get_y (_tmp35_);
#line 353 "../src/Layout.vala"
				_tmp37_ = _tmp36_;
#line 353 "../src/Layout.vala"
				_tmp38_ = sb;
#line 353 "../src/Layout.vala"
				_tmp39_ = node_bounds_get_height (_tmp38_);
#line 353 "../src/Layout.vala"
				_tmp40_ = _tmp39_;
#line 353 "../src/Layout.vala"
				_tmp41_ = cb;
#line 353 "../src/Layout.vala"
				_tmp42_ = node_bounds_get_y (_tmp41_);
#line 353 "../src/Layout.vala"
				_tmp43_ = _tmp42_;
#line 353 "../src/Layout.vala"
				node_set_posy (child, ((_tmp37_ + _tmp40_) + (oy - _tmp43_)) - adjust);
#line 3140 "Layout.c"
			} else {
				NodeBounds* _tmp44_;
				gdouble _tmp45_;
				gdouble _tmp46_;
				NodeBounds* _tmp47_;
				gdouble _tmp48_;
				gdouble _tmp49_;
				NodeBounds* _tmp50_;
				gdouble _tmp51_;
				gdouble _tmp52_;
#line 355 "../src/Layout.vala"
				_tmp44_ = sb;
#line 355 "../src/Layout.vala"
				_tmp45_ = node_bounds_get_x (_tmp44_);
#line 355 "../src/Layout.vala"
				_tmp46_ = _tmp45_;
#line 355 "../src/Layout.vala"
				_tmp47_ = sb;
#line 355 "../src/Layout.vala"
				_tmp48_ = node_bounds_get_width (_tmp47_);
#line 355 "../src/Layout.vala"
				_tmp49_ = _tmp48_;
#line 355 "../src/Layout.vala"
				_tmp50_ = cb;
#line 355 "../src/Layout.vala"
				_tmp51_ = node_bounds_get_x (_tmp50_);
#line 355 "../src/Layout.vala"
				_tmp52_ = _tmp51_;
#line 355 "../src/Layout.vala"
				node_set_posx (child, ((_tmp46_ + _tmp49_) + (ox - _tmp52_)) - adjust);
#line 3171 "Layout.c"
			}
#line 350 "../src/Layout.vala"
			_node_bounds_unref0 (sb);
#line 3175 "Layout.c"
		} else {
			NodeBounds* sb = NULL;
			GArray* _tmp53_;
			GArray* _tmp54_;
			Node* _tmp55_;
			NodeSide _tmp56_;
			NodeSide _tmp57_;
			NodeBounds* _tmp58_;
			NodeBounds* _tmp59_;
			NodeSide _tmp60_;
			NodeSide _tmp61_;
#line 360 "../src/Layout.vala"
			_tmp53_ = node_children (parent);
#line 360 "../src/Layout.vala"
			_tmp54_ = _tmp53_;
#line 360 "../src/Layout.vala"
			_tmp55_ = g_array_index (_tmp54_, Node*, (guint) (pos + 1));
#line 360 "../src/Layout.vala"
			_tmp56_ = node_get_side (child);
#line 360 "../src/Layout.vala"
			_tmp57_ = _tmp56_;
#line 360 "../src/Layout.vala"
			_tmp58_ = layout_bbox (self, _tmp55_, (gint) _tmp57_);
#line 360 "../src/Layout.vala"
			_tmp59_ = _tmp58_;
#line 360 "../src/Layout.vala"
			_g_array_unref0 (_tmp54_);
#line 360 "../src/Layout.vala"
			sb = _tmp59_;
#line 361 "../src/Layout.vala"
			_tmp60_ = node_get_side (child);
#line 361 "../src/Layout.vala"
			_tmp61_ = _tmp60_;
#line 361 "../src/Layout.vala"
			if ((_tmp61_ & node_side_horizontal ()) != 0) {
#line 3211 "Layout.c"
				NodeBounds* _tmp62_;
				gdouble _tmp63_;
				gdouble _tmp64_;
				NodeBounds* _tmp65_;
				gdouble _tmp66_;
				gdouble _tmp67_;
#line 362 "../src/Layout.vala"
				_tmp62_ = sb;
#line 362 "../src/Layout.vala"
				_tmp63_ = node_bounds_get_y (_tmp62_);
#line 362 "../src/Layout.vala"
				_tmp64_ = _tmp63_;
#line 362 "../src/Layout.vala"
				_tmp65_ = cb;
#line 362 "../src/Layout.vala"
				_tmp66_ = node_bounds_get_y (_tmp65_);
#line 362 "../src/Layout.vala"
				_tmp67_ = _tmp66_;
#line 362 "../src/Layout.vala"
				node_set_posy (child, (_tmp64_ + (oy - _tmp67_)) - adjust);
#line 3232 "Layout.c"
			} else {
				NodeBounds* _tmp68_;
				gdouble _tmp69_;
				gdouble _tmp70_;
				NodeBounds* _tmp71_;
				gdouble _tmp72_;
				gdouble _tmp73_;
#line 364 "../src/Layout.vala"
				_tmp68_ = sb;
#line 364 "../src/Layout.vala"
				_tmp69_ = node_bounds_get_x (_tmp68_);
#line 364 "../src/Layout.vala"
				_tmp70_ = _tmp69_;
#line 364 "../src/Layout.vala"
				_tmp71_ = cb;
#line 364 "../src/Layout.vala"
				_tmp72_ = node_bounds_get_x (_tmp71_);
#line 364 "../src/Layout.vala"
				_tmp73_ = _tmp72_;
#line 364 "../src/Layout.vala"
				node_set_posx (child, (_tmp70_ + (ox - _tmp73_)) - adjust);
#line 3254 "Layout.c"
			}
#line 350 "../src/Layout.vala"
			_node_bounds_unref0 (sb);
#line 3258 "Layout.c"
		}
	}
#line 368 "../src/Layout.vala"
	_tmp74_ = node_get_tree_bbox (child);
#line 368 "../src/Layout.vala"
	_tmp75_ = _tmp74_;
#line 368 "../src/Layout.vala"
	layout_adjust_tree_all (self, child, _tmp75_, 0 - adjust, "by_insert");
#line 320 "../src/Layout.vala"
	_node_bounds_unref0 (cb);
#line 3269 "Layout.c"
}

void
layout_handle_update_by_insert (Layout* self,
                                Node* parent,
                                Node* child,
                                gint pos)
{
	LayoutClass* _klass_;
#line 320 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 320 "../src/Layout.vala"
	if (_klass_->handle_update_by_insert) {
#line 320 "../src/Layout.vala"
		_klass_->handle_update_by_insert (self, parent, child, pos);
#line 3287 "Layout.c"
	}
}

static void
layout_real_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size)
{
	gdouble adjust = 0.0;
	NodeBounds* _tmp25_;
	NodeBounds* _tmp26_;
#line 373 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 375 "../src/Layout.vala"
	adjust = size / 2;
#line 3305 "Layout.c"
	{
		gint i = 0;
#line 378 "../src/Layout.vala"
		i = 0;
#line 3310 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 378 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 378 "../src/Layout.vala"
			while (TRUE) {
#line 3317 "Layout.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
				Node* n = NULL;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				NodeSide _tmp11_;
				NodeSide _tmp12_;
#line 378 "../src/Layout.vala"
				if (!_tmp0_) {
#line 3332 "Layout.c"
					gint _tmp1_;
#line 378 "../src/Layout.vala"
					_tmp1_ = i;
#line 378 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 3338 "Layout.c"
				}
#line 378 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 378 "../src/Layout.vala"
				_tmp2_ = node_children (parent);
#line 378 "../src/Layout.vala"
				_tmp3_ = _tmp2_;
#line 378 "../src/Layout.vala"
				_tmp4_ = !(((guint) i) < _tmp3_->len);
#line 378 "../src/Layout.vala"
				_g_array_unref0 (_tmp3_);
#line 378 "../src/Layout.vala"
				if (_tmp4_) {
#line 378 "../src/Layout.vala"
					break;
#line 3354 "Layout.c"
				}
#line 379 "../src/Layout.vala"
				_tmp5_ = node_children (parent);
#line 379 "../src/Layout.vala"
				_tmp6_ = _tmp5_;
#line 379 "../src/Layout.vala"
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 379 "../src/Layout.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 379 "../src/Layout.vala"
				_tmp9_ = _tmp8_;
#line 379 "../src/Layout.vala"
				_g_array_unref0 (_tmp6_);
#line 379 "../src/Layout.vala"
				n = _tmp9_;
#line 380 "../src/Layout.vala"
				_tmp10_ = n;
#line 380 "../src/Layout.vala"
				_tmp11_ = node_get_side (_tmp10_);
#line 380 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 380 "../src/Layout.vala"
				if (_tmp12_ == side) {
#line 3378 "Layout.c"
					gdouble _tmp13_ = 0.0;
					gdouble current_adjust = 0.0;
					Node* _tmp14_;
					NodeSide _tmp15_;
					NodeSide _tmp16_;
#line 381 "../src/Layout.vala"
					if (i >= index) {
#line 381 "../src/Layout.vala"
						_tmp13_ = 0 - adjust;
#line 3388 "Layout.c"
					} else {
#line 381 "../src/Layout.vala"
						_tmp13_ = adjust;
#line 3392 "Layout.c"
					}
#line 381 "../src/Layout.vala"
					current_adjust = _tmp13_;
#line 382 "../src/Layout.vala"
					_tmp14_ = n;
#line 382 "../src/Layout.vala"
					_tmp15_ = node_get_side (_tmp14_);
#line 382 "../src/Layout.vala"
					_tmp16_ = _tmp15_;
#line 382 "../src/Layout.vala"
					if ((_tmp16_ & node_side_horizontal ()) != 0) {
#line 3404 "Layout.c"
						Node* _tmp17_;
						Node* _tmp18_;
						gdouble _tmp19_;
						gdouble _tmp20_;
#line 383 "../src/Layout.vala"
						_tmp17_ = n;
#line 383 "../src/Layout.vala"
						_tmp18_ = n;
#line 383 "../src/Layout.vala"
						_tmp19_ = node_get_posy (_tmp18_);
#line 383 "../src/Layout.vala"
						_tmp20_ = _tmp19_;
#line 383 "../src/Layout.vala"
						node_set_posy (_tmp18_, _tmp20_ + current_adjust);
#line 3419 "Layout.c"
					} else {
						Node* _tmp21_;
						Node* _tmp22_;
						gdouble _tmp23_;
						gdouble _tmp24_;
#line 385 "../src/Layout.vala"
						_tmp21_ = n;
#line 385 "../src/Layout.vala"
						_tmp22_ = n;
#line 385 "../src/Layout.vala"
						_tmp23_ = node_get_posx (_tmp22_);
#line 385 "../src/Layout.vala"
						_tmp24_ = _tmp23_;
#line 385 "../src/Layout.vala"
						node_set_posx (_tmp22_, _tmp24_ + current_adjust);
#line 3435 "Layout.c"
					}
				}
#line 378 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 3440 "Layout.c"
			}
		}
	}
#line 391 "../src/Layout.vala"
	_tmp25_ = node_get_tree_bbox (parent);
#line 391 "../src/Layout.vala"
	_tmp26_ = _tmp25_;
#line 391 "../src/Layout.vala"
	layout_adjust_tree_all (self, parent, _tmp26_, 0 - (layout_get_adjust (self, parent) / 2), "by_delete");
#line 3450 "Layout.c"
}

void
layout_handle_update_by_delete (Layout* self,
                                Node* parent,
                                gint index,
                                NodeSide side,
                                gdouble size)
{
	LayoutClass* _klass_;
#line 373 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 373 "../src/Layout.vala"
	if (_klass_->handle_update_by_delete) {
#line 373 "../src/Layout.vala"
		_klass_->handle_update_by_delete (self, parent, index, side, size);
#line 3469 "Layout.c"
	}
}

static void
layout_real_position_root (Layout* self,
                           Node* last,
                           Node* n)
{
	NodeBounds* nb = NULL;
	NodeBounds* _tmp0_;
	NodeBounds* _tmp1_;
	NodeBounds* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
#line 396 "../src/Layout.vala"
	g_return_if_fail (last != NULL);
#line 396 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 397 "../src/Layout.vala"
	_tmp0_ = node_get_tree_bbox (last);
#line 397 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 397 "../src/Layout.vala"
	_tmp2_ = _node_bounds_ref0 (_tmp1_);
#line 397 "../src/Layout.vala"
	nb = _tmp2_;
#line 398 "../src/Layout.vala"
	_tmp3_ = node_get_posx (last);
#line 398 "../src/Layout.vala"
	_tmp4_ = _tmp3_;
#line 398 "../src/Layout.vala"
	node_set_posx (n, _tmp4_);
#line 399 "../src/Layout.vala"
	_tmp5_ = node_bounds_get_y (nb);
#line 399 "../src/Layout.vala"
	_tmp6_ = _tmp5_;
#line 399 "../src/Layout.vala"
	_tmp7_ = node_bounds_get_height (nb);
#line 399 "../src/Layout.vala"
	_tmp8_ = _tmp7_;
#line 399 "../src/Layout.vala"
	node_set_posy (n, (_tmp6_ + _tmp8_) + self->_rt_gap);
#line 396 "../src/Layout.vala"
	_node_bounds_unref0 (nb);
#line 3518 "Layout.c"
}

void
layout_position_root (Layout* self,
                      Node* last,
                      Node* n)
{
	LayoutClass* _klass_;
#line 396 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/Layout.vala"
	_klass_ = LAYOUT_GET_CLASS (self);
#line 396 "../src/Layout.vala"
	if (_klass_->position_root) {
#line 396 "../src/Layout.vala"
		_klass_->position_root (self, last, n);
#line 3535 "Layout.c"
	}
}

const gchar*
layout_get_name (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Layout.vala"
	_tmp0_ = self->priv->_name;
#line 26 "../src/Layout.vala"
	result = _tmp0_;
#line 26 "../src/Layout.vala"
	return result;
#line 3552 "Layout.c"
}

void
layout_set_name (Layout* self,
                 const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Layout.vala"
	old_value = layout_get_name (self);
#line 26 "../src/Layout.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3566 "Layout.c"
		gchar* _tmp0_;
#line 26 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Layout.vala"
		_g_free0 (self->priv->_name);
#line 26 "../src/Layout.vala"
		self->priv->_name = _tmp0_;
#line 26 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_NAME_PROPERTY]);
#line 3576 "Layout.c"
	}
}

const gchar*
layout_get_icon (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Layout.vala"
	_tmp0_ = self->priv->_icon;
#line 27 "../src/Layout.vala"
	result = _tmp0_;
#line 27 "../src/Layout.vala"
	return result;
#line 3593 "Layout.c"
}

void
layout_set_icon (Layout* self,
                 const gchar* value)
{
	gchar* old_value;
#line 27 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Layout.vala"
	old_value = layout_get_icon (self);
#line 27 "../src/Layout.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3607 "Layout.c"
		gchar* _tmp0_;
#line 27 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Layout.vala"
		_g_free0 (self->priv->_icon);
#line 27 "../src/Layout.vala"
		self->priv->_icon = _tmp0_;
#line 27 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_ICON_PROPERTY]);
#line 3617 "Layout.c"
	}
}

gboolean
layout_get_balanceable (Layout* self)
{
	gboolean result;
#line 28 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Layout.vala"
	result = self->priv->_balanceable;
#line 28 "../src/Layout.vala"
	return result;
#line 3631 "Layout.c"
}

void
layout_set_balanceable (Layout* self,
                        gboolean value)
{
	gboolean old_value;
#line 28 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Layout.vala"
	old_value = layout_get_balanceable (self);
#line 28 "../src/Layout.vala"
	if (old_value != value) {
#line 28 "../src/Layout.vala"
		self->priv->_balanceable = value;
#line 28 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_BALANCEABLE_PROPERTY]);
#line 3649 "Layout.c"
	}
}

static void
layout_class_init (LayoutClass * klass,
                   gpointer klass_data)
{
#line 22 "../src/Layout.vala"
	layout_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Layout.vala"
	g_type_class_adjust_private_offset (klass, &Layout_private_offset);
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_real_side_mapping;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_real_initialize;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->bbox = (NodeBounds* (*) (Layout*, Node*, gint)) layout_real_bbox;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree = (void (*) (Layout*, Node*, gint, gint, gdouble)) layout_real_adjust_tree;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree_all = (void (*) (Layout*, Node*, NodeBounds*, gdouble, const gchar*)) layout_real_adjust_tree_all;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->propagate_side = (void (*) (Layout*, Node*, NodeSide)) layout_real_propagate_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_side = (NodeSide (*) (Layout*, Node*)) layout_real_get_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_real_set_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_real_handle_update_by_edit;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_real_handle_update_by_fold;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_insert_adjust = (gdouble (*) (Layout*, Node*)) layout_real_get_insert_adjust;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_real_handle_update_by_insert;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_real_handle_update_by_delete;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->position_root = (void (*) (Layout*, Node*, Node*)) layout_real_position_root;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_layout_get_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_layout_set_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->finalize = layout_finalize;
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_NAME_PROPERTY, layout_properties[LAYOUT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_ICON_PROPERTY, layout_properties[LAYOUT_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_BALANCEABLE_PROPERTY, layout_properties[LAYOUT_BALANCEABLE_PROPERTY] = g_param_spec_boolean ("balanceable", "balanceable", "balanceable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3701 "Layout.c"
}

static void
layout_instance_init (Layout * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 22 "../src/Layout.vala"
	self->priv = layout_get_instance_private (self);
#line 24 "../src/Layout.vala"
	self->_rt_gap = (gdouble) 100;
#line 26 "../src/Layout.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../src/Layout.vala"
	self->priv->_name = _tmp0_;
#line 27 "../src/Layout.vala"
	_tmp1_ = g_strdup ("");
#line 27 "../src/Layout.vala"
	self->priv->_icon = _tmp1_;
#line 28 "../src/Layout.vala"
	self->priv->_balanceable = FALSE;
#line 3724 "Layout.c"
}

static void
layout_finalize (GObject * obj)
{
	Layout * self;
#line 22 "../src/Layout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LAYOUT, Layout);
#line 26 "../src/Layout.vala"
	_g_free0 (self->priv->_name);
#line 27 "../src/Layout.vala"
	_g_free0 (self->priv->_icon);
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (layout_parent_class)->finalize (obj);
#line 3739 "Layout.c"
}

static GType
layout_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Layout), 0, (GInstanceInitFunc) layout_instance_init, NULL };
	GType layout_type_id;
	layout_type_id = g_type_register_static (G_TYPE_OBJECT, "Layout", &g_define_type_info, 0);
	Layout_private_offset = g_type_add_instance_private (layout_type_id, sizeof (LayoutPrivate));
	return layout_type_id;
}

GType
layout_get_type (void)
{
	static volatile gsize layout_type_id__once = 0;
	if (g_once_init_enter (&layout_type_id__once)) {
		GType layout_type_id;
		layout_type_id = layout_get_type_once ();
		g_once_init_leave (&layout_type_id__once, layout_type_id);
	}
	return layout_type_id__once;
}

static void
_vala_layout_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_name (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_icon (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_boolean (value, layout_get_balanceable (self));
#line 22 "../src/Layout.vala"
		break;
#line 3792 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3798 "Layout.c"
	}
}

static void
_vala_layout_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_name (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_icon (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_balanceable (self, g_value_get_boolean (value));
#line 22 "../src/Layout.vala"
		break;
#line 3830 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3836 "Layout.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

